(function(global, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports) : typeof define === "function" && define.amd ? define(["exports"], factory) : (global = typeof globalThis !== "undefined" ? globalThis : global || self, factory(global.vrembem = {}));
})(this, function(exports2) {
  "use strict";
  var b$2 = (t, e, n) => {
    if (!e.has(t))
      throw TypeError("Cannot " + n);
  };
  var o$1 = (t, e, n) => (b$2(t, e, "read from private field"), n ? n.call(t) : e.get(t)), f$2 = (t, e, n) => {
    if (e.has(t))
      throw TypeError("Cannot add the same private member more than once");
    e instanceof WeakSet ? e.add(t) : e.set(t, n);
  }, a = (t, e, n, i2) => (b$2(t, e, "write to private field"), i2 ? i2.call(t, n) : e.set(t, n), n);
  var r$2;
  let $$2 = class $ {
    constructor(e, n) {
      f$2(this, r$2, void 0);
      this.value = e, a(this, r$2, n), this.mql = null;
    }
    get handler() {
      return o$1(this, r$2);
    }
    // Unmount existing handler before setting a new one.
    set handler(e) {
      this.mql && (typeof this.mql.removeEventListener == "function" ? this.mql.removeEventListener("change", o$1(this, r$2)) : this.mql.removeListener(o$1(this, r$2))), a(this, r$2, e);
    }
    mount(e, n) {
      return e && (this.value = e), n && a(this, r$2, n), this.value ? (this.mql = window.matchMedia(`(min-width: ${this.value})`), typeof this.mql.addEventListener == "function" ? this.mql.addEventListener("change", o$1(this, r$2)) : this.mql.addListener(o$1(this, r$2)), o$1(this, r$2).call(this, this.mql), this) : this;
    }
    unmount() {
      return this.mql ? (typeof this.mql.removeEventListener == "function" ? this.mql.removeEventListener("change", o$1(this, r$2)) : this.mql.removeListener(o$1(this, r$2)), this.value = null, a(this, r$2, null), this.mql = null, this) : this;
    }
  };
  r$2 = /* @__PURE__ */ new WeakMap();
  let T$2 = class T {
    constructor() {
      this.collection = [];
    }
    async register(e) {
      return await this.deregister(e), this.collection.push(e), this.collection;
    }
    async deregister(e) {
      const n = this.collection.findIndex((i2) => i2 === e);
      if (n >= 0) {
        const i2 = this.collection[n];
        Object.getOwnPropertyNames(i2).forEach((l2) => {
          delete i2[l2];
        }), this.collection.splice(n, 1);
      }
      return this.collection;
    }
    async registerCollection(e) {
      return await Promise.all(Array.from(e, (n) => {
        this.register(n);
      })), this.collection;
    }
    async deregisterCollection() {
      for (; this.collection.length > 0; )
        await this.deregister(this.collection[0]);
      return this.collection;
    }
    get(e, n = "id") {
      return this.collection.find((i2) => i2[n] === e);
    }
  };
  const s = {
    inert: ":not([inert]):not([inert] *)",
    negTabIndex: ':not([tabindex^="-"])',
    disabled: ":not(:disabled)"
  }, v$2 = [
    `a[href]${s.inert}${s.negTabIndex}`,
    `area[href]${s.inert}${s.negTabIndex}`,
    `input:not([type="hidden"]):not([type="radio"])${s.inert}${s.negTabIndex}${s.disabled}`,
    `input[type="radio"]${s.inert}${s.negTabIndex}${s.disabled}`,
    `select${s.inert}${s.negTabIndex}${s.disabled}`,
    `textarea${s.inert}${s.negTabIndex}${s.disabled}`,
    `button${s.inert}${s.negTabIndex}${s.disabled}`,
    `details${s.inert} > summary:first-of-type${s.negTabIndex}`,
    // Discard until Firefox supports `:has()`
    // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
    // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
    `iframe${s.inert}${s.negTabIndex}`,
    `audio[controls]${s.inert}${s.negTabIndex}`,
    `video[controls]${s.inert}${s.negTabIndex}`,
    `[contenteditable]${s.inert}${s.negTabIndex}`,
    `[tabindex]${s.inert}${s.negTabIndex}`
  ];
  var h$2, d$1, u$2;
  let x$1 = class x {
    constructor(e = null, n = "[data-focus]") {
      f$2(this, h$2, void 0);
      f$2(this, d$1, void 0);
      f$2(this, u$2, void 0);
      this.el = e, this.selectorFocus = n, a(this, d$1, p$2.bind(this)), a(this, u$2, g$2.bind(this));
    }
    get focusable() {
      return o$1(this, h$2);
    }
    set focusable(e) {
      a(this, h$2, e), o$1(this, h$2).length ? (document.removeEventListener("keydown", o$1(this, u$2)), document.addEventListener("keydown", o$1(this, d$1))) : (document.removeEventListener("keydown", o$1(this, d$1)), document.addEventListener("keydown", o$1(this, u$2)));
    }
    get focusableFirst() {
      return this.focusable[0];
    }
    get focusableLast() {
      return this.focusable[this.focusable.length - 1];
    }
    mount(e, n) {
      e && (this.el = e), n && (this.selectorFocus = n), this.focusable = this.getFocusable(), this.focus();
    }
    unmount() {
      this.el = null, this.focusable = [], document.removeEventListener("keydown", o$1(this, d$1)), document.removeEventListener("keydown", o$1(this, u$2));
    }
    focus(e = this.el, n = this.selectorFocus) {
      (e.querySelector(n) || e).focus();
    }
    getFocusable(e = this.el) {
      const n = [], i2 = document.activeElement, l2 = e.scrollTop;
      return e.querySelectorAll(v$2.join(",")).forEach((m2) => {
        m2.focus(), document.activeElement === m2 && n.push(m2);
      }), e.scrollTop = l2, i2.focus(), n;
    }
  };
  h$2 = /* @__PURE__ */ new WeakMap(), d$1 = /* @__PURE__ */ new WeakMap(), u$2 = /* @__PURE__ */ new WeakMap();
  function p$2(t) {
    (t.key === "Tab" || t.keyCode === 9) && (t.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (t.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (t.preventDefault(), this.focusableFirst.focus()));
  }
  function g$2(t) {
    (t.key === "Tab" || t.keyCode === 9) && t.preventDefault();
  }
  function q$2(t, e) {
    const i2 = (t.getAttribute(`data-${e}`) || "").replace(/'/g, '"');
    return i2 ? JSON.parse(i2) : {};
  }
  function I$3() {
    return getComputedStyle(document.body).getPropertyValue("--vrembem-variable-prefix").trim();
  }
  function C$2(t, e = true) {
    const n = localStorage.getItem(t), i2 = n ? JSON.parse(n) : {};
    return {
      get(l2) {
        return l2 ? i2[l2] : i2;
      },
      set(l2, c2) {
        return c2 ? i2[l2] = c2 : delete i2[l2], e && localStorage.setItem(t, JSON.stringify(i2)), i2;
      }
    };
  }
  function O$2(t, e, n) {
    const i2 = e.nodeType === Node.COMMENT_NODE, l2 = e.nodeType === Node.ELEMENT_NODE;
    if (e = i2 || l2 ? e : document.querySelector(e), i2 && (n = "after"), !e)
      throw new Error(`Not a valid teleport reference: '${e}'`);
    if (typeof e[n] != "function")
      throw new Error(`Not a valid teleport method: '${n}'`);
    let c2 = null;
    return i2 || (c2 = document.createComment("teleported #" + t.id), t.before(c2)), e[n](t), i2 && e.remove(), c2;
  }
  const S$3 = (t, e) => new Promise((n) => {
    e.transition ? (t.classList.remove(e.stateClosed), t.classList.add(e.stateOpening), t.addEventListener("transitionend", function i2() {
      t.classList.add(e.stateOpened), t.classList.remove(e.stateOpening), n(t), this.removeEventListener("transitionend", i2);
    })) : (t.classList.add(e.stateOpened), t.classList.remove(e.stateClosed), n(t));
  }), F$3 = (t, e) => new Promise((n) => {
    e.transition ? (t.classList.add(e.stateClosing), t.classList.remove(e.stateOpened), t.addEventListener("transitionend", function i2() {
      t.classList.remove(e.stateClosing), t.classList.add(e.stateClosed), n(t), this.removeEventListener("transitionend", i2);
    })) : (t.classList.add(e.stateClosed), t.classList.remove(e.stateOpened), n(t));
  });
  function y$2(t, e) {
    e && document.querySelectorAll(e).forEach((i2) => {
      t ? i2.style.overflow = "hidden" : i2.style.removeProperty("overflow");
    });
  }
  function L$2(t, e) {
    e && document.querySelectorAll(e).forEach((i2) => {
      t ? (i2.inert = true, i2.setAttribute("aria-hidden", true)) : (i2.inert = null, i2.removeAttribute("aria-hidden"));
    });
  }
  function k$3(t, e) {
    L$2(!!t, e.selectorInert), y$2(!!t, e.selectorOverflow);
  }
  const index = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
    __proto__: null,
    Breakpoint: $$2,
    Collection: T$2,
    FocusTrap: x$1,
    closeTransition: F$3,
    getConfig: q$2,
    getPrefix: I$3,
    localStore: C$2,
    openTransition: S$3,
    teleport: O$2,
    updateGlobalState: k$3
  }, Symbol.toStringTag, { value: "Module" }));
  const i = {
    autoInit: false,
    stateAttr: "aria-checked",
    stateValue: "mixed"
  };
  let r$1 = class r {
    constructor(t) {
      this.defaults = i, this.settings = { ...this.defaults, ...t }, this.__handlerClick = this.handlerClick.bind(this), this.settings.autoInit && this.init();
    }
    init(t = null) {
      t && (this.settings = { ...this.settings, ...t });
      const e = `[${this.settings.stateAttr}="${this.settings.stateValue}"]`, s2 = document.querySelectorAll(e);
      this.setIndeterminate(s2), document.addEventListener("click", this.__handlerClick, false);
    }
    destroy() {
      document.removeEventListener("click", this.__handlerClick, false);
    }
    handlerClick(t) {
      const e = `[${this.settings.stateAttr}="${this.settings.stateValue}"]`, s2 = t.target.closest(e);
      s2 && (this.removeAriaState(s2), this.setIndeterminate(s2));
    }
    setAriaState(t, e = this.settings.stateValue) {
      t = t.forEach ? t : [t], t.forEach((s2) => {
        s2.setAttribute(this.settings.stateAttr, e);
      });
    }
    removeAriaState(t) {
      t = t.forEach ? t : [t], t.forEach((e) => {
        e.removeAttribute(this.settings.stateAttr);
      });
    }
    setIndeterminate(t) {
      t = t.forEach ? t : [t], t.forEach((e) => {
        e.hasAttribute(this.settings.stateAttr) ? e.indeterminate = true : e.indeterminate = false;
      });
    }
  };
  var S$2 = (t, e, s2) => {
    if (!e.has(t))
      throw TypeError("Cannot " + s2);
  };
  var p$1 = (t, e, s2) => (S$2(t, e, "read from private field"), s2 ? s2.call(t) : e.get(t)), E$1 = (t, e, s2) => {
    if (e.has(t))
      throw TypeError("Cannot add the same private member more than once");
    e instanceof WeakSet ? e.add(t) : e.set(t, s2);
  }, $$1 = (t, e, s2, i2) => (S$2(t, e, "write to private field"), i2 ? i2.call(t, s2) : e.set(t, s2), s2);
  var I$2 = (t, e, s2) => {
    if (!e.has(t))
      throw TypeError("Cannot " + s2);
  }, l$1 = (t, e, s2) => (I$2(t, e, "read from private field"), s2 ? s2.call(t) : e.get(t)), w$1 = (t, e, s2) => {
    if (e.has(t))
      throw TypeError("Cannot add the same private member more than once");
    e instanceof WeakSet ? e.add(t) : e.set(t, s2);
  }, h$1 = (t, e, s2, i2) => (I$2(t, e, "write to private field"), i2 ? i2.call(t, s2) : e.set(t, s2), s2), c$1;
  let M$2 = class M {
    constructor(e, s2) {
      w$1(this, c$1, void 0), this.value = e, h$1(this, c$1, s2), this.mql = null;
    }
    get handler() {
      return l$1(this, c$1);
    }
    // Unmount existing handler before setting a new one.
    set handler(e) {
      this.mql && (typeof this.mql.removeEventListener == "function" ? this.mql.removeEventListener("change", l$1(this, c$1)) : this.mql.removeListener(l$1(this, c$1))), h$1(this, c$1, e);
    }
    mount(e, s2) {
      return e && (this.value = e), s2 && h$1(this, c$1, s2), this.value ? (this.mql = window.matchMedia(`(min-width: ${this.value})`), typeof this.mql.addEventListener == "function" ? this.mql.addEventListener("change", l$1(this, c$1)) : this.mql.addListener(l$1(this, c$1)), l$1(this, c$1).call(this, this.mql), this) : this;
    }
    unmount() {
      return this.mql ? (typeof this.mql.removeEventListener == "function" ? this.mql.removeEventListener("change", l$1(this, c$1)) : this.mql.removeListener(l$1(this, c$1)), this.value = null, h$1(this, c$1, null), this.mql = null, this) : this;
    }
  };
  c$1 = /* @__PURE__ */ new WeakMap();
  let P$1 = class P {
    constructor() {
      this.collection = [];
    }
    async register(e) {
      return await this.deregister(e), this.collection.push(e), this.collection;
    }
    async deregister(e) {
      const s2 = this.collection.findIndex((i2) => i2 === e);
      if (s2 >= 0) {
        const i2 = this.collection[s2];
        Object.getOwnPropertyNames(i2).forEach((n) => {
          delete i2[n];
        }), this.collection.splice(s2, 1);
      }
      return this.collection;
    }
    async registerCollection(e) {
      return await Promise.all(Array.from(e, (s2) => {
        this.register(s2);
      })), this.collection;
    }
    async deregisterCollection() {
      for (; this.collection.length > 0; )
        await this.deregister(this.collection[0]);
      return this.collection;
    }
    get(e, s2 = "id") {
      return this.collection.find((i2) => i2[s2] === e);
    }
  };
  const r = {
    inert: ":not([inert]):not([inert] *)",
    negTabIndex: ':not([tabindex^="-"])',
    disabled: ":not(:disabled)"
  }, F$2 = [
    `a[href]${r.inert}${r.negTabIndex}`,
    `area[href]${r.inert}${r.negTabIndex}`,
    `input:not([type="hidden"]):not([type="radio"])${r.inert}${r.negTabIndex}${r.disabled}`,
    `input[type="radio"]${r.inert}${r.negTabIndex}${r.disabled}`,
    `select${r.inert}${r.negTabIndex}${r.disabled}`,
    `textarea${r.inert}${r.negTabIndex}${r.disabled}`,
    `button${r.inert}${r.negTabIndex}${r.disabled}`,
    `details${r.inert} > summary:first-of-type${r.negTabIndex}`,
    // Discard until Firefox supports `:has()`
    // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
    // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
    `iframe${r.inert}${r.negTabIndex}`,
    `audio[controls]${r.inert}${r.negTabIndex}`,
    `video[controls]${r.inert}${r.negTabIndex}`,
    `[contenteditable]${r.inert}${r.negTabIndex}`,
    `[tabindex]${r.inert}${r.negTabIndex}`
  ];
  var v$1, u$1, g$1;
  let B$2 = class B {
    constructor(e = null, s2 = "[data-focus]") {
      w$1(this, v$1, void 0), w$1(this, u$1, void 0), w$1(this, g$1, void 0), this.el = e, this.selectorFocus = s2, h$1(this, u$1, _$2.bind(this)), h$1(this, g$1, N$2.bind(this));
    }
    get focusable() {
      return l$1(this, v$1);
    }
    set focusable(e) {
      h$1(this, v$1, e), l$1(this, v$1).length ? (document.removeEventListener("keydown", l$1(this, g$1)), document.addEventListener("keydown", l$1(this, u$1))) : (document.removeEventListener("keydown", l$1(this, u$1)), document.addEventListener("keydown", l$1(this, g$1)));
    }
    get focusableFirst() {
      return this.focusable[0];
    }
    get focusableLast() {
      return this.focusable[this.focusable.length - 1];
    }
    mount(e, s2) {
      e && (this.el = e), s2 && (this.selectorFocus = s2), this.focusable = this.getFocusable(), this.focus();
    }
    unmount() {
      this.el = null, this.focusable = [], document.removeEventListener("keydown", l$1(this, u$1)), document.removeEventListener("keydown", l$1(this, g$1));
    }
    focus(e = this.el, s2 = this.selectorFocus) {
      (e.querySelector(s2) || e).focus();
    }
    getFocusable(e = this.el) {
      const s2 = [], i2 = document.activeElement, n = e.scrollTop;
      return e.querySelectorAll(F$2.join(",")).forEach((a2) => {
        a2.focus(), document.activeElement === a2 && s2.push(a2);
      }), e.scrollTop = n, i2.focus(), s2;
    }
  };
  v$1 = /* @__PURE__ */ new WeakMap(), u$1 = /* @__PURE__ */ new WeakMap(), g$1 = /* @__PURE__ */ new WeakMap();
  function _$2(t) {
    (t.key === "Tab" || t.keyCode === 9) && (t.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (t.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (t.preventDefault(), this.focusableFirst.focus()));
  }
  function N$2(t) {
    (t.key === "Tab" || t.keyCode === 9) && t.preventDefault();
  }
  function K$2(t, e) {
    const s2 = (t.getAttribute(`data-${e}`) || "").replace(/'/g, '"');
    return s2 ? JSON.parse(s2) : {};
  }
  function W$1() {
    return getComputedStyle(document.body).getPropertyValue("--vrembem-variable-prefix").trim();
  }
  function V(t, e = true) {
    const s2 = localStorage.getItem(t), i2 = s2 ? JSON.parse(s2) : {};
    return {
      get(n) {
        return n ? i2[n] : i2;
      },
      set(n, a2) {
        return a2 ? i2[n] = a2 : delete i2[n], e && localStorage.setItem(t, JSON.stringify(i2)), i2;
      }
    };
  }
  const J$2 = (t, e) => new Promise((s2) => {
    e.transition ? (t.classList.remove(e.stateClosed), t.classList.add(e.stateOpening), t.addEventListener("transitionend", function i2() {
      t.classList.add(e.stateOpened), t.classList.remove(e.stateOpening), s2(t), this.removeEventListener("transitionend", i2);
    })) : (t.classList.add(e.stateOpened), t.classList.remove(e.stateClosed), s2(t));
  }), z$1 = (t, e) => new Promise((s2) => {
    e.transition ? (t.classList.add(e.stateClosing), t.classList.remove(e.stateOpened), t.addEventListener("transitionend", function i2() {
      t.classList.remove(e.stateClosing), t.classList.add(e.stateClosed), s2(t), this.removeEventListener("transitionend", i2);
    })) : (t.classList.add(e.stateClosed), t.classList.remove(e.stateOpened), s2(t));
  });
  function G$1(t, e) {
    e && document.querySelectorAll(e).forEach((s2) => {
      t ? s2.style.overflow = "hidden" : s2.style.removeProperty("overflow");
    });
  }
  function H$2(t, e) {
    e && document.querySelectorAll(e).forEach((s2) => {
      t ? (s2.inert = true, s2.setAttribute("aria-hidden", true)) : (s2.inert = null, s2.removeAttribute("aria-hidden"));
    });
  }
  function k$2(t, e) {
    H$2(!!t, e.selectorInert), G$1(!!t, e.selectorOverflow);
  }
  const Q$1 = {
    autoInit: false,
    // Data attributes
    dataOpen: "drawer-open",
    dataClose: "drawer-close",
    dataToggle: "drawer-toggle",
    dataBreakpoint: "drawer-breakpoint",
    dataConfig: "drawer-config",
    // Selectors
    selectorDrawer: ".drawer",
    selectorDialog: ".drawer__dialog",
    selectorFocus: "[data-focus]",
    selectorInert: null,
    selectorOverflow: "body",
    // State classes
    stateOpened: "is-opened",
    stateOpening: "is-opening",
    stateClosing: "is-closing",
    stateClosed: "is-closed",
    // Classes
    classModal: "drawer_modal",
    // Feature toggles
    breakpoints: null,
    customEventPrefix: "drawer:",
    eventListeners: true,
    store: true,
    storeKey: "VB:DrawerState",
    setTabindex: true,
    transition: true
  };
  function R$1(t) {
    const e = t.target.closest(`
    [data-${this.settings.dataOpen}],
    [data-${this.settings.dataToggle}],
    [data-${this.settings.dataClose}]
  `);
    if (e) {
      t.preventDefault(), e.matches(`[data-${this.settings.dataToggle}]`) && e.getAttribute(`data-${this.settings.dataToggle}`).trim().split(" ").forEach((i2) => {
        const n = this.get(i2);
        n.trigger = e, n.toggle();
      }), e.matches(`[data-${this.settings.dataOpen}]`) && e.getAttribute(`data-${this.settings.dataOpen}`).trim().split(" ").forEach((i2) => {
        const n = this.get(i2);
        n.trigger = e, n.open();
      }), e.matches(`[data-${this.settings.dataClose}]`) && e.getAttribute(`data-${this.settings.dataClose}`).trim().split(" ").forEach((i2) => {
        if (i2) {
          const n = this.get(i2);
          n.trigger = e, n.close();
        } else {
          const n = t.target.closest(this.settings.selectorDrawer);
          n && this.close(n);
        }
      });
      return;
    }
    t.target.matches(this.settings.selectorDrawer) && this.close(t.target.id);
  }
  function U$1(t) {
    if (t.key === "Escape") {
      const e = this.activeModal;
      e && this.close(e);
    }
  }
  async function L$1(t, e = true) {
    if (!t)
      return this.collection;
    const s2 = this.collection.findIndex((i2) => i2.id === t.id);
    if (s2 >= 0) {
      const i2 = this.collection[s2];
      e && i2.state === "opened" && await i2.close(false), this.store.set(i2.id), i2.unmountBreakpoint(), Object.getOwnPropertyNames(i2).forEach((n) => {
        delete i2[n];
      }), this.collection.splice(s2, 1);
    }
    return this.collection;
  }
  function X(t) {
    const e = W$1(), s2 = t.getAttribute(`data-${this.settings.dataBreakpoint}`);
    return this.settings.breakpoints && this.settings.breakpoints[s2] ? this.settings.breakpoints[s2] : getComputedStyle(document.body).getPropertyValue(`--${e}breakpoint-${s2}`).trim() ? getComputedStyle(document.body).getPropertyValue(`--${e}breakpoint-${s2}`).trim() : s2;
  }
  function y$1(t) {
    const e = typeof t == "string" ? this.get(t) : this.get(t.id);
    if (e)
      return e;
    throw new Error(`Drawer not found in collection with id of "${t.id || t}".`);
  }
  function O$1(t) {
    return typeof t == "string" ? t : typeof t.hasAttribute == "function" ? t.hasAttribute(`data-${this.settings.dataOpen}`) ? t.getAttribute(`data-${this.settings.dataOpen}`) : t.hasAttribute(`data-${this.settings.dataClose}`) ? t.getAttribute(`data-${this.settings.dataClose}`) || false : t.hasAttribute(`data-${this.settings.dataToggle}`) ? t.getAttribute(`data-${this.settings.dataToggle}`) : t.closest(this.settings.selectorDrawer) ? (t = t.closest(this.settings.selectorDrawer), t.id || false) : false : t.id ? t.id : false;
  }
  function Y(t) {
    const e = O$1.call(this, t);
    if (e) {
      const s2 = document.querySelector(`#${e}`), i2 = s2 ? s2.querySelector(this.settings.selectorDialog) : null;
      return !s2 && !i2 ? { error: new Error(`No drawer elements found using the ID: "${e}".`) } : i2 ? { drawer: s2, dialog: i2 } : { error: new Error("Drawer is missing dialog element.") };
    } else
      return { error: new Error("Could not resolve the drawer ID.") };
  }
  async function A$1(t) {
    this.store.get(t.id) ? this.store.get(t.id) === "opened" ? await t.open(false, false) : await t.close(false, false) : t.el.classList.contains(this.settings.stateOpened) ? t.state = "opened" : (t.el.classList.remove(this.settings.stateOpening), t.el.classList.remove(this.settings.stateClosing), t.el.classList.add(this.settings.stateClosed));
  }
  function D$2(t) {
    t.state === "opened" ? t.mode === "modal" ? this.focusTrap.mount(t.dialog, this.settings.selectorFocus) : this.focusTrap.focus(t.dialog, this.settings.selectorFocus) : (t.trigger && (t.trigger.focus(), t.trigger = null), this.focusTrap.unmount());
  }
  async function C$1(t, e, s2 = true) {
    const i2 = y$1.call(this, t), n = { ...this.settings, ...i2.settings };
    return e !== void 0 && (n.transition = e), i2.state === "closed" && (i2.state = "opening", await J$2(i2.el, n), i2.mode === "modal" && k$2(true, n), i2.state = "opened"), s2 && D$2.call(this, i2), i2.el.dispatchEvent(new CustomEvent(n.customEventPrefix + "opened", {
      detail: this,
      bubbles: true
    })), i2;
  }
  async function b$1(t, e, s2 = true) {
    const i2 = y$1.call(this, t), n = { ...this.settings, ...i2.settings };
    return e !== void 0 && (n.transition = e), i2.state === "opened" && (i2.state = "closing", document.activeElement.blur(), await z$1(i2.el, n), i2.mode === "modal" && k$2(false, n), s2 && D$2.call(this, i2), i2.state = "closed", i2.el.dispatchEvent(new CustomEvent(n.customEventPrefix + "closed", {
      detail: this,
      bubbles: true
    }))), i2;
  }
  async function q$1(t, e, s2) {
    const i2 = y$1.call(this, t);
    return i2.state === "closed" ? C$1.call(this, i2, e, s2) : b$1.call(this, i2, e, s2);
  }
  function Z$1(t) {
    switch (t.mode) {
      case "inline":
        return j.call(this, t);
      case "modal":
        return tt$1.call(this, t);
      default:
        throw new Error(`"${t.mode}" is not a valid drawer mode.`);
    }
  }
  async function j(t) {
    return t.el.classList.remove(t.getSetting("classModal")), t.dialog.removeAttribute("aria-modal"), k$2(false, { ...this.settings, ...t.settings }), this.focusTrap.unmount(), await A$1.call(this, t), t.el.dispatchEvent(new CustomEvent(t.getSetting("customEventPrefix") + "switchMode", {
      detail: this,
      bubbles: true
    })), t;
  }
  async function tt$1(t) {
    return t.el.classList.add(t.getSetting("classModal")), t.dialog.setAttribute("aria-modal", "true"), !this.store.get(t.id) && t.el.classList.contains(t.getSetting("stateOpened")) && this.store.set(t.id, "opened"), await b$1.call(this, t, false, false), t.el.dispatchEvent(new CustomEvent(t.getSetting("customEventPrefix") + "switchMode", {
      detail: this,
      bubbles: true
    })), t;
  }
  async function et$1(t, e) {
    await L$1.call(this, t, false);
    const s2 = this, i2 = new M$2(), n = {
      open(o2, d2) {
        return C$1.call(s2, this, o2, d2);
      },
      close(o2, d2) {
        return b$1.call(s2, this, o2, d2);
      },
      toggle(o2, d2) {
        return q$1.call(s2, this, o2, d2);
      },
      deregister() {
        return L$1.call(s2, this);
      },
      mountBreakpoint() {
        const o2 = this.breakpoint, d2 = this.handleBreakpoint.bind(this);
        return i2.mount(o2, d2), this;
      },
      unmountBreakpoint() {
        return i2.unmount(), this;
      },
      handleBreakpoint(o2) {
        return this.mode = o2.matches ? "inline" : "modal", this;
      },
      getSetting(o2) {
        return o2 in this.settings ? this.settings[o2] : s2.settings[o2];
      }
    }, a2 = {
      id: t.id,
      el: t,
      dialog: e,
      trigger: null,
      settings: K$2(t, this.settings.dataConfig),
      get breakpoint() {
        return X.call(s2, t);
      },
      get state() {
        return T2;
      },
      set state(o2) {
        T2 = o2, (o2 === "opened" || o2 === "closed") && this.mode === "inline" && s2.store.set(this.id, this.state);
      },
      get mode() {
        return x2;
      },
      set mode(o2) {
        x2 = o2, Z$1.call(s2, this);
      },
      ...n
    };
    let T2 = t.classList.contains(a2.getSetting("stateOpened")) ? "opened" : "closed", x2 = t.classList.contains(a2.getSetting("classModal")) ? "modal" : "inline";
    return a2.mode === "modal" ? a2.dialog.setAttribute("aria-modal", "true") : a2.dialog.removeAttribute("aria-modal"), a2.getSetting("setTabindex") && a2.dialog.setAttribute("tabindex", "-1"), this.collection.push(a2), a2.breakpoint ? a2.mountBreakpoint() : await A$1.call(this, a2), a2;
  }
  var f$1, m$1;
  let it$1 = class it extends P$1 {
    constructor(s2) {
      super();
      E$1(this, f$1, void 0);
      E$1(this, m$1, void 0);
      this.defaults = Q$1, this.settings = { ...this.defaults, ...s2 }, this.focusTrap = new B$2(), this.store = V(this.settings.storeKey, this.settings.store), $$1(this, f$1, R$1.bind(this)), $$1(this, m$1, U$1.bind(this)), this.settings.autoInit && this.init();
    }
    get activeModal() {
      return this.collection.find((s2) => s2.state === "opened" && s2.mode === "modal");
    }
    async init(s2 = null) {
      s2 && (this.settings = { ...this.settings, ...s2 });
      const i2 = document.querySelectorAll(this.settings.selectorDrawer);
      return await this.registerCollection(i2), this.settings.eventListeners && this.initEventListeners(), this;
    }
    async destroy() {
      return await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(), this;
    }
    initEventListeners() {
      document.addEventListener("click", p$1(this, f$1), false), document.addEventListener("keydown", p$1(this, m$1), false);
    }
    destroyEventListeners() {
      document.removeEventListener("click", p$1(this, f$1), false), document.removeEventListener("keydown", p$1(this, m$1), false);
    }
    register(s2) {
      const i2 = Y.call(this, s2);
      return i2.error ? Promise.reject(i2.error) : et$1.call(this, i2.drawer, i2.dialog);
    }
    deregister(s2) {
      const i2 = this.get(O$1.call(this, s2));
      return L$1.call(this, i2);
    }
    open(s2, i2, n) {
      return C$1.call(this, s2, i2, n);
    }
    close(s2, i2, n) {
      return b$1.call(this, s2, i2, n);
    }
    toggle(s2, i2, n) {
      return q$1.call(this, s2, i2, n);
    }
  };
  f$1 = /* @__PURE__ */ new WeakMap(), m$1 = /* @__PURE__ */ new WeakMap();
  var I$1 = (t, e, s2) => {
    if (!e.has(t))
      throw TypeError("Cannot " + s2);
  };
  var f = (t, e, s2) => (I$1(t, e, "read from private field"), s2 ? s2.call(t) : e.get(t)), v = (t, e, s2) => {
    if (e.has(t))
      throw TypeError("Cannot add the same private member more than once");
    e instanceof WeakSet ? e.add(t) : e.set(t, s2);
  }, b = (t, e, s2, i2) => (I$1(t, e, "write to private field"), i2 ? i2.call(t, s2) : e.set(t, s2), s2);
  var k$1 = (t, e, s2) => {
    if (!e.has(t))
      throw TypeError("Cannot " + s2);
  }, o = (t, e, s2) => (k$1(t, e, "read from private field"), s2 ? s2.call(t) : e.get(t)), y = (t, e, s2) => {
    if (e.has(t))
      throw TypeError("Cannot add the same private member more than once");
    e instanceof WeakSet ? e.add(t) : e.set(t, s2);
  }, E = (t, e, s2, i2) => (k$1(t, e, "write to private field"), i2 ? i2.call(t, s2) : e.set(t, s2), s2);
  class A {
    constructor() {
      this.collection = [];
    }
    async register(e) {
      return await this.deregister(e), this.collection.push(e), this.collection;
    }
    async deregister(e) {
      const s2 = this.collection.findIndex((i2) => i2 === e);
      if (s2 >= 0) {
        const i2 = this.collection[s2];
        Object.getOwnPropertyNames(i2).forEach((n) => {
          delete i2[n];
        }), this.collection.splice(s2, 1);
      }
      return this.collection;
    }
    async registerCollection(e) {
      return await Promise.all(Array.from(e, (s2) => {
        this.register(s2);
      })), this.collection;
    }
    async deregisterCollection() {
      for (; this.collection.length > 0; )
        await this.deregister(this.collection[0]);
      return this.collection;
    }
    get(e, s2 = "id") {
      return this.collection.find((i2) => i2[s2] === e);
    }
  }
  const l = {
    inert: ":not([inert]):not([inert] *)",
    negTabIndex: ':not([tabindex^="-"])',
    disabled: ":not(:disabled)"
  }, S$1 = [
    `a[href]${l.inert}${l.negTabIndex}`,
    `area[href]${l.inert}${l.negTabIndex}`,
    `input:not([type="hidden"]):not([type="radio"])${l.inert}${l.negTabIndex}${l.disabled}`,
    `input[type="radio"]${l.inert}${l.negTabIndex}${l.disabled}`,
    `select${l.inert}${l.negTabIndex}${l.disabled}`,
    `textarea${l.inert}${l.negTabIndex}${l.disabled}`,
    `button${l.inert}${l.negTabIndex}${l.disabled}`,
    `details${l.inert} > summary:first-of-type${l.negTabIndex}`,
    // Discard until Firefox supports `:has()`
    // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
    // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
    `iframe${l.inert}${l.negTabIndex}`,
    `audio[controls]${l.inert}${l.negTabIndex}`,
    `video[controls]${l.inert}${l.negTabIndex}`,
    `[contenteditable]${l.inert}${l.negTabIndex}`,
    `[tabindex]${l.inert}${l.negTabIndex}`
  ];
  var g, c, d;
  let M$1 = class M {
    constructor(e = null, s2 = "[data-focus]") {
      y(this, g, void 0), y(this, c, void 0), y(this, d, void 0), this.el = e, this.selectorFocus = s2, E(this, c, R.bind(this)), E(this, d, N$1.bind(this));
    }
    get focusable() {
      return o(this, g);
    }
    set focusable(e) {
      E(this, g, e), o(this, g).length ? (document.removeEventListener("keydown", o(this, d)), document.addEventListener("keydown", o(this, c))) : (document.removeEventListener("keydown", o(this, c)), document.addEventListener("keydown", o(this, d)));
    }
    get focusableFirst() {
      return this.focusable[0];
    }
    get focusableLast() {
      return this.focusable[this.focusable.length - 1];
    }
    mount(e, s2) {
      e && (this.el = e), s2 && (this.selectorFocus = s2), this.focusable = this.getFocusable(), this.focus();
    }
    unmount() {
      this.el = null, this.focusable = [], document.removeEventListener("keydown", o(this, c)), document.removeEventListener("keydown", o(this, d));
    }
    focus(e = this.el, s2 = this.selectorFocus) {
      (e.querySelector(s2) || e).focus();
    }
    getFocusable(e = this.el) {
      const s2 = [], i2 = document.activeElement, n = e.scrollTop;
      return e.querySelectorAll(S$1.join(",")).forEach((r2) => {
        r2.focus(), document.activeElement === r2 && s2.push(r2);
      }), e.scrollTop = n, i2.focus(), s2;
    }
  };
  g = /* @__PURE__ */ new WeakMap(), c = /* @__PURE__ */ new WeakMap(), d = /* @__PURE__ */ new WeakMap();
  function R(t) {
    (t.key === "Tab" || t.keyCode === 9) && (t.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (t.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (t.preventDefault(), this.focusableFirst.focus()));
  }
  function N$1(t) {
    (t.key === "Tab" || t.keyCode === 9) && t.preventDefault();
  }
  function P(t, e) {
    const s2 = (t.getAttribute(`data-${e}`) || "").replace(/'/g, '"');
    return s2 ? JSON.parse(s2) : {};
  }
  function T$1(t, e, s2) {
    const i2 = e.nodeType === Node.COMMENT_NODE, n = e.nodeType === Node.ELEMENT_NODE;
    if (e = i2 || n ? e : document.querySelector(e), i2 && (s2 = "after"), !e)
      throw new Error(`Not a valid teleport reference: '${e}'`);
    if (typeof e[s2] != "function")
      throw new Error(`Not a valid teleport method: '${s2}'`);
    let r2 = null;
    return i2 || (r2 = document.createComment("teleported #" + t.id), t.before(r2)), e[s2](t), i2 && e.remove(), r2;
  }
  const D$1 = (t, e) => new Promise((s2) => {
    e.transition ? (t.classList.remove(e.stateClosed), t.classList.add(e.stateOpening), t.addEventListener("transitionend", function i2() {
      t.classList.add(e.stateOpened), t.classList.remove(e.stateOpening), s2(t), this.removeEventListener("transitionend", i2);
    })) : (t.classList.add(e.stateOpened), t.classList.remove(e.stateClosed), s2(t));
  }), F$1 = (t, e) => new Promise((s2) => {
    e.transition ? (t.classList.add(e.stateClosing), t.classList.remove(e.stateOpened), t.addEventListener("transitionend", function i2() {
      t.classList.remove(e.stateClosing), t.classList.add(e.stateClosed), s2(t), this.removeEventListener("transitionend", i2);
    })) : (t.classList.add(e.stateClosed), t.classList.remove(e.stateOpened), s2(t));
  });
  function q(t, e) {
    e && document.querySelectorAll(e).forEach((s2) => {
      t ? s2.style.overflow = "hidden" : s2.style.removeProperty("overflow");
    });
  }
  function z(t, e) {
    e && document.querySelectorAll(e).forEach((s2) => {
      t ? (s2.inert = true, s2.setAttribute("aria-hidden", true)) : (s2.inert = null, s2.removeAttribute("aria-hidden"));
    });
  }
  function W(t, e) {
    z(!!t, e.selectorInert), q(!!t, e.selectorOverflow);
  }
  const _$1 = {
    autoInit: false,
    // Data attributes
    dataOpen: "modal-open",
    dataClose: "modal-close",
    dataReplace: "modal-replace",
    dataConfig: "modal-config",
    // Selectors
    selectorModal: ".modal",
    selectorDialog: ".modal__dialog",
    selectorRequired: '[role="alertdialog"]',
    selectorFocus: "[data-focus]",
    selectorInert: null,
    selectorOverflow: "body",
    // State classes
    stateOpened: "is-opened",
    stateOpening: "is-opening",
    stateClosing: "is-closing",
    stateClosed: "is-closed",
    // Feature settings
    customEventPrefix: "modal:",
    eventListeners: true,
    teleport: null,
    teleportMethod: "append",
    setTabindex: true,
    transition: true
  };
  function L(t) {
    const e = typeof t == "string" ? this.get(t) : this.get(t.id);
    if (e)
      return e;
    throw new Error(`Modal not found in collection with id of "${t.id || t}".`);
  }
  function p(t) {
    return typeof t == "string" ? t : typeof t.hasAttribute == "function" ? t.hasAttribute(`data-${this.settings.dataOpen}`) ? t.getAttribute(`data-${this.settings.dataOpen}`) : t.hasAttribute(`data-${this.settings.dataClose}`) ? t.getAttribute(`data-${this.settings.dataClose}`) || false : t.hasAttribute(`data-${this.settings.dataReplace}`) ? t.getAttribute(`data-${this.settings.dataReplace}`) : t.closest(this.settings.selectorModal) ? (t = t.closest(this.settings.selectorModal), t.id || false) : false : t.id ? t.id : false;
  }
  function G(t) {
    const e = p.call(this, t);
    if (e) {
      const s2 = document.querySelector(`#${e}`), i2 = s2 ? s2.querySelector(this.settings.selectorDialog) : null;
      return !s2 && !i2 ? { error: new Error(`No modal elements found using the ID: "${e}".`) } : i2 ? { modal: s2, dialog: i2 } : { error: new Error("Modal is missing dialog element.") };
    } else
      return { error: new Error("Could not resolve the modal ID.") };
  }
  function m() {
    this.active ? this.focusTrap.mount(this.active.dialog, this.settings.selectorFocus) : (this.trigger && (this.trigger.focus(), this.trigger = null), this.focusTrap.unmount());
  }
  async function K$1(t) {
    let e = t.target.closest(
      `[data-${this.settings.dataOpen}], [data-${this.settings.dataReplace}]`
    );
    if (e) {
      t.preventDefault(), t.target.closest(this.settings.selectorModal) || (this.trigger = e);
      const i2 = this.get(p.call(this, e));
      return e.matches(`[data-${this.settings.dataOpen}]`) ? i2.open() : i2.replace();
    }
    if (e = t.target.closest(`[data-${this.settings.dataClose}]`), e) {
      t.preventDefault();
      const s2 = e.getAttribute(`data-${this.settings.dataClose}`);
      return s2 === "*" ? this.closeAll() : this.close(s2);
    }
    if (t.target.matches(this.settings.selectorModal) && !t.target.querySelector(this.settings.selectorRequired))
      return this.close(p.call(this, t.target));
  }
  function J$1(t) {
    if (t.key === "Escape" && this.active && !this.active.dialog.matches(this.settings.selectorRequired))
      return this.close();
  }
  async function w(t, e = true) {
    if (!t)
      return this.collection;
    const s2 = this.collection.findIndex((i2) => i2.id === t.id);
    if (s2 >= 0) {
      const i2 = this.collection[s2];
      e && i2.state === "opened" ? await i2.close(false) : this.stack.remove(i2), i2.getSetting("teleport") && i2.teleportReturn(), Object.getOwnPropertyNames(i2).forEach((n) => {
        delete i2[n];
      }), this.collection.splice(s2, 1);
    }
    return this.collection;
  }
  async function x(t, e, s2 = true) {
    const i2 = L.call(this, t), n = { ...this.settings, ...i2.settings };
    return e !== void 0 && (n.transition = e), this.stack.moveToTop(i2), i2.state === "closed" && (i2.state = "opening", this.stack.add(i2), await D$1(i2.el, n), i2.state = "opened"), s2 && m.call(this), i2.el.dispatchEvent(new CustomEvent(n.customEventPrefix + "opened", {
      detail: this,
      bubbles: true
    })), i2;
  }
  async function C(t, e, s2 = true) {
    const i2 = t ? L.call(this, t) : this.active;
    if (i2 && i2.state === "opened") {
      i2.state = "closing";
      const n = { ...this.settings, ...i2.settings };
      e !== void 0 && (n.transition = e), document.activeElement.blur(), await F$1(i2.el, n), this.stack.remove(i2), s2 && m.call(this), i2.state = "closed", i2.el.dispatchEvent(new CustomEvent(n.customEventPrefix + "closed", {
        detail: this,
        bubbles: true
      }));
    }
    return i2;
  }
  async function $(t, e) {
    const s2 = [];
    return await Promise.all(this.stack.value.map(async (i2) => {
      t && t === i2.id ? Promise.resolve() : s2.push(await C.call(this, i2, e, false)), i2.trigger = null;
    })), s2;
  }
  async function O(t, e, s2 = true) {
    const i2 = L.call(this, t);
    let n, r2;
    return i2.state === "opened" ? (n = i2, r2 = await $.call(this, i2.id, e)) : (n = x.call(this, i2, e, false), r2 = $.call(this, false, e), await Promise.all([n, r2])), s2 && m.call(this), { opened: n, closed: r2 };
  }
  async function B$1(t, e) {
    await w.call(this, t, false);
    const s2 = this, i2 = {
      open(r2, a2) {
        return x.call(s2, this, r2, a2);
      },
      close(r2, a2) {
        return C.call(s2, this, r2, a2);
      },
      replace(r2, a2) {
        return O.call(s2, this, r2, a2);
      },
      deregister() {
        return w.call(s2, this);
      },
      teleport(r2 = this.getSetting("teleport"), a2 = this.getSetting("teleportMethod")) {
        return this.returnRef ? (console.error("Element has already been teleported:", this.el), false) : (this.returnRef = T$1(this.el, r2, a2), this.el);
      },
      teleportReturn() {
        return this.returnRef ? (this.returnRef = T$1(this.el, this.returnRef), this.el) : (console.error("No return reference found:", this.el), false);
      },
      getSetting(r2) {
        return r2 in this.settings ? this.settings[r2] : s2.settings[r2];
      }
    }, n = {
      id: t.id,
      state: "closed",
      el: t,
      dialog: e,
      returnRef: null,
      settings: P(t, this.settings.dataConfig),
      ...i2
    };
    return n.dialog.setAttribute("aria-modal", "true"), n.dialog.hasAttribute("role") || n.dialog.setAttribute("role", "dialog"), n.getSetting("setTabindex") && n.dialog.setAttribute("tabindex", "-1"), n.getSetting("teleport") && n.teleport(), this.collection.push(n), n.el.classList.contains(this.settings.stateOpened) ? await n.open(false) : (n.el.classList.remove(this.settings.stateOpening), n.el.classList.remove(this.settings.stateClosing), n.el.classList.add(this.settings.stateClosed)), n;
  }
  function H$1(t) {
    const e = [];
    return {
      get value() {
        return [...e];
      },
      get top() {
        return e[e.length - 1];
      },
      updateIndex() {
        e.forEach((s2, i2) => {
          s2.el.style.zIndex = null;
          const n = getComputedStyle(s2.el)["z-index"];
          s2.el.style.zIndex = parseInt(n) + i2 + 1;
        });
      },
      updateGlobalState() {
        W(this.top, t), this.updateIndex();
      },
      add(s2) {
        s2.el.style.zIndex = null;
        const i2 = getComputedStyle(s2.el)["z-index"];
        s2.el.style.zIndex = parseInt(i2) + e.length + 1, e.push(s2), this.updateGlobalState();
      },
      remove(s2) {
        const i2 = e.findIndex((n) => n.id === s2.id);
        i2 >= 0 && (s2.el.style.zIndex = null, e.splice(i2, 1), this.updateGlobalState());
      },
      moveToTop(s2) {
        const i2 = e.findIndex((n) => n.id === s2.id);
        i2 >= 0 && (e.splice(i2, 1), this.add(s2));
      }
    };
  }
  var u, h;
  class U extends A {
    constructor(s2) {
      super();
      v(this, u, void 0);
      v(this, h, void 0);
      this.defaults = _$1, this.settings = { ...this.defaults, ...s2 }, this.trigger = null, this.focusTrap = new M$1(), this.stack = H$1(this.settings), b(this, u, K$1.bind(this)), b(this, h, J$1.bind(this)), this.settings.autoInit && this.init();
    }
    get active() {
      return this.stack.top;
    }
    async init(s2) {
      s2 && (this.settings = { ...this.settings, ...s2 });
      const i2 = document.querySelectorAll(this.settings.selectorModal);
      return await this.registerCollection(i2), this.settings.eventListeners && this.initEventListeners(), this;
    }
    async destroy() {
      return this.trigger = null, await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(), this;
    }
    initEventListeners() {
      document.addEventListener("click", f(this, u), false), document.addEventListener("keydown", f(this, h), false);
    }
    destroyEventListeners() {
      document.removeEventListener("click", f(this, u), false), document.removeEventListener("keydown", f(this, h), false);
    }
    register(s2) {
      const i2 = G.call(this, s2);
      return i2.error ? Promise.reject(i2.error) : B$1.call(this, i2.modal, i2.dialog);
    }
    deregister(s2) {
      const i2 = this.get(p.call(this, s2));
      return w.call(this, i2);
    }
    open(s2, i2, n) {
      return x.call(this, s2, i2, n);
    }
    close(s2, i2, n) {
      return C.call(this, s2, i2, n);
    }
    replace(s2, i2, n) {
      return O.call(this, s2, i2, n);
    }
    async closeAll(s2 = false, i2, n = true) {
      const r2 = await $.call(this, s2, i2);
      return n && m.call(this), r2;
    }
  }
  u = /* @__PURE__ */ new WeakMap(), h = /* @__PURE__ */ new WeakMap();
  var Ue = (e, t, r2) => {
    if (!t.has(e))
      throw TypeError("Cannot " + r2);
  };
  var Ae = (e, t, r2) => (Ue(e, t, "read from private field"), r2 ? r2.call(e) : t.get(e)), _e = (e, t, r2) => {
    if (t.has(e))
      throw TypeError("Cannot add the same private member more than once");
    t instanceof WeakSet ? t.add(e) : t.set(e, r2);
  }, Ke = (e, t, r2, i2) => (Ue(e, t, "write to private field"), i2 ? i2.call(e, r2) : t.set(e, r2), r2);
  class Ct {
    constructor() {
      this.collection = [];
    }
    async register(t) {
      return await this.deregister(t), this.collection.push(t), this.collection;
    }
    async deregister(t) {
      const r2 = this.collection.findIndex((i2) => i2 === t);
      if (r2 >= 0) {
        const i2 = this.collection[r2];
        Object.getOwnPropertyNames(i2).forEach((n) => {
          delete i2[n];
        }), this.collection.splice(r2, 1);
      }
      return this.collection;
    }
    async registerCollection(t) {
      return await Promise.all(Array.from(t, (r2) => {
        this.register(r2);
      })), this.collection;
    }
    async deregisterCollection() {
      for (; this.collection.length > 0; )
        await this.deregister(this.collection[0]);
      return this.collection;
    }
    get(t, r2 = "id") {
      return this.collection.find((i2) => i2[r2] === t);
    }
  }
  function kt() {
    return getComputedStyle(document.body).getPropertyValue("--vrembem-variable-prefix").trim();
  }
  const Dt = {
    autoInit: false,
    // Selectors
    selectorPopover: ".popover",
    selectorArrow: ".popover__arrow",
    // State classes
    stateActive: "is-active",
    // Feature settings
    eventListeners: true,
    eventType: "click",
    placement: "bottom"
  };
  function ot(e, t) {
    const r2 = getComputedStyle(e), i2 = {
      placement: t.placement,
      event: t.eventType,
      offset: 0,
      "overflow-padding": 0,
      "flip-padding": 0,
      "arrow-element": t.selectorArrow,
      "arrow-padding": 0
    };
    for (const n in i2) {
      const o2 = kt(), l2 = r2.getPropertyValue(`--${o2}popover-${n}`).trim();
      l2 && (i2[n] = l2);
    }
    return i2;
  }
  function Pe(e) {
    let t;
    const r2 = typeof e == "string" ? e.trim().split(" ") : [e];
    switch (r2.forEach(function(i2, n) {
      r2[n] = parseInt(i2, 10);
    }), r2.length) {
      case 1:
        t = r2[0];
        break;
      case 2:
        t = {
          top: r2[0],
          right: r2[1],
          bottom: r2[0],
          left: r2[1]
        };
        break;
      case 3:
        t = {
          top: r2[0],
          right: r2[1],
          bottom: r2[2],
          left: r2[1]
        };
        break;
      case 4:
        t = {
          top: r2[0],
          right: r2[1],
          bottom: r2[2],
          left: r2[3]
        };
        break;
      default:
        t = false;
        break;
    }
    return t;
  }
  function Rt(e) {
    return [{
      name: "offset",
      options: {
        offset: [0, parseInt(e.offset, 10)]
      }
    }, {
      name: "preventOverflow",
      options: {
        padding: Pe(e["overflow-padding"])
      }
    }, {
      name: "flip",
      options: {
        padding: Pe(e["flip-padding"])
      }
    }, {
      name: "arrow",
      options: {
        element: e["arrow-element"],
        padding: Pe(e["arrow-padding"])
      }
    }];
  }
  function at(e) {
    const t = typeof e == "string" ? this.get(e) : this.get(e.id);
    if (t)
      return t;
    throw new Error(`Popover not found in collection with id of "${e}".`);
  }
  function st(e) {
    return typeof e == "string" ? e : typeof e.hasAttribute == "function" ? e.closest(this.settings.selectorPopover) ? (e = e.closest(this.settings.selectorPopover), e.id) : e.hasAttribute("aria-controls") ? e.getAttribute("aria-controls") : e.hasAttribute("aria-describedby") ? e.getAttribute("aria-describedby") : false : e.id ? e.id : false;
  }
  function Bt(e) {
    const t = st.call(this, e);
    if (t) {
      const r2 = document.querySelector(`#${t}`), i2 = document.querySelector(`[aria-controls="${t}"]`) || document.querySelector(`[aria-describedby="${t}"]`);
      return !i2 && !r2 ? { error: new Error(`No popover elements found using the ID: "${t}".`) } : i2 ? r2 ? { popover: r2, trigger: i2 } : { error: new Error("No popover associated with the provided popover trigger.") } : { error: new Error("No popover trigger associated with the provided popover.") };
    } else
      return { error: new Error("Could not resolve the popover ID.") };
  }
  async function ke(e) {
    const t = e ? at.call(this, e) : await ct.call(this);
    return t && t.state === "opened" && (t.el.classList.remove(this.settings.stateActive), t.trigger.hasAttribute("aria-controls") && t.trigger.setAttribute("aria-expanded", "false"), t.popper.setOptions({
      modifiers: [{ name: "eventListeners", enabled: false }]
    }), t.state = "closed", t.trigger === this.trigger && (this.trigger = null)), t;
  }
  async function ct() {
    const e = [];
    return await Promise.all(this.collection.map(async (t) => {
      t.state === "opened" && e.push(await ke.call(this, t));
    })), e;
  }
  function lt(e) {
    e.state == "opened" && setTimeout(() => {
      const t = e.el.closest(":hover") === e.el || e.trigger.closest(":hover") === e.trigger, r2 = document.activeElement.closest(
        `#${e.id}, [aria-controls="${e.id}"], [aria-describedby="${e.id}"]`
      );
      return !t && !r2 && e.close(), e;
    }, 1);
  }
  function Tt(e) {
    e.state === "opened" ? e.close() : (this.trigger = e.trigger, e.open(), ft.call(this, e));
  }
  function St(e) {
    switch (e.key) {
      case "Escape":
        this.trigger && this.trigger.focus(), ct.call(this);
        return;
      case "Tab":
        this.collection.forEach((t) => {
          lt.call(this, t);
        });
        return;
      default:
        return;
    }
  }
  function ft(e) {
    const t = this;
    document.addEventListener("click", function r2(i2) {
      i2.target.closest(
        `#${e.id}, [aria-controls="${e.id}"], [aria-describedby="${e.id}"]`
      ) ? e.el && !e.el.classList.contains(t.settings.stateActive) && this.removeEventListener("click", r2) : (e.el && e.el.classList.contains(t.settings.stateActive) && e.close(), this.removeEventListener("click", r2));
    });
  }
  var k = "top", S = "bottom", M = "right", D = "left", De = "auto", le = [k, S, M, D], Q = "start", se = "end", Mt = "clippingParents", ut = "viewport", ne = "popper", Wt = "reference", Ge = /* @__PURE__ */ le.reduce(function(e, t) {
    return e.concat([t + "-" + Q, t + "-" + se]);
  }, []), pt = /* @__PURE__ */ [].concat(le, [De]).reduce(function(e, t) {
    return e.concat([t, t + "-" + Q, t + "-" + se]);
  }, []), jt = "beforeRead", Ht = "read", Nt = "afterRead", It = "beforeMain", Vt = "main", Ft = "afterMain", qt = "beforeWrite", Xt = "write", Yt = "afterWrite", zt = [jt, Ht, Nt, It, Vt, Ft, qt, Xt, Yt];
  function N(e) {
    return e ? (e.nodeName || "").toLowerCase() : null;
  }
  function B(e) {
    if (e == null)
      return window;
    if (e.toString() !== "[object Window]") {
      var t = e.ownerDocument;
      return t && t.defaultView || window;
    }
    return e;
  }
  function K(e) {
    var t = B(e).Element;
    return e instanceof t || e instanceof Element;
  }
  function T(e) {
    var t = B(e).HTMLElement;
    return e instanceof t || e instanceof HTMLElement;
  }
  function Re(e) {
    if (typeof ShadowRoot > "u")
      return false;
    var t = B(e).ShadowRoot;
    return e instanceof t || e instanceof ShadowRoot;
  }
  function Ut(e) {
    var t = e.state;
    Object.keys(t.elements).forEach(function(r2) {
      var i2 = t.styles[r2] || {}, n = t.attributes[r2] || {}, o2 = t.elements[r2];
      !T(o2) || !N(o2) || (Object.assign(o2.style, i2), Object.keys(n).forEach(function(l2) {
        var s2 = n[l2];
        s2 === false ? o2.removeAttribute(l2) : o2.setAttribute(l2, s2 === true ? "" : s2);
      }));
    });
  }
  function _t(e) {
    var t = e.state, r2 = {
      popper: {
        position: t.options.strategy,
        left: "0",
        top: "0",
        margin: "0"
      },
      arrow: {
        position: "absolute"
      },
      reference: {}
    };
    return Object.assign(t.elements.popper.style, r2.popper), t.styles = r2, t.elements.arrow && Object.assign(t.elements.arrow.style, r2.arrow), function() {
      Object.keys(t.elements).forEach(function(i2) {
        var n = t.elements[i2], o2 = t.attributes[i2] || {}, l2 = Object.keys(t.styles.hasOwnProperty(i2) ? t.styles[i2] : r2[i2]), s2 = l2.reduce(function(a2, f2) {
          return a2[f2] = "", a2;
        }, {});
        !T(n) || !N(n) || (Object.assign(n.style, s2), Object.keys(o2).forEach(function(a2) {
          n.removeAttribute(a2);
        }));
      });
    };
  }
  const Kt = {
    name: "applyStyles",
    enabled: true,
    phase: "write",
    fn: Ut,
    effect: _t,
    requires: ["computeStyles"]
  };
  function H(e) {
    return e.split("-")[0];
  }
  var _ = Math.max, ye = Math.min, Z = Math.round;
  function Le() {
    var e = navigator.userAgentData;
    return e != null && e.brands && Array.isArray(e.brands) ? e.brands.map(function(t) {
      return t.brand + "/" + t.version;
    }).join(" ") : navigator.userAgent;
  }
  function dt() {
    return !/^((?!chrome|android).)*safari/i.test(Le());
  }
  function ee(e, t, r2) {
    t === void 0 && (t = false), r2 === void 0 && (r2 = false);
    var i2 = e.getBoundingClientRect(), n = 1, o2 = 1;
    t && T(e) && (n = e.offsetWidth > 0 && Z(i2.width) / e.offsetWidth || 1, o2 = e.offsetHeight > 0 && Z(i2.height) / e.offsetHeight || 1);
    var l2 = K(e) ? B(e) : window, s2 = l2.visualViewport, a2 = !dt() && r2, f2 = (i2.left + (a2 && s2 ? s2.offsetLeft : 0)) / n, c2 = (i2.top + (a2 && s2 ? s2.offsetTop : 0)) / o2, h2 = i2.width / n, y2 = i2.height / o2;
    return {
      width: h2,
      height: y2,
      top: c2,
      right: f2 + h2,
      bottom: c2 + y2,
      left: f2,
      x: f2,
      y: c2
    };
  }
  function Be(e) {
    var t = ee(e), r2 = e.offsetWidth, i2 = e.offsetHeight;
    return Math.abs(t.width - r2) <= 1 && (r2 = t.width), Math.abs(t.height - i2) <= 1 && (i2 = t.height), {
      x: e.offsetLeft,
      y: e.offsetTop,
      width: r2,
      height: i2
    };
  }
  function vt(e, t) {
    var r2 = t.getRootNode && t.getRootNode();
    if (e.contains(t))
      return true;
    if (r2 && Re(r2)) {
      var i2 = t;
      do {
        if (i2 && e.isSameNode(i2))
          return true;
        i2 = i2.parentNode || i2.host;
      } while (i2);
    }
    return false;
  }
  function I(e) {
    return B(e).getComputedStyle(e);
  }
  function Gt(e) {
    return ["table", "td", "th"].indexOf(N(e)) >= 0;
  }
  function F(e) {
    return ((K(e) ? e.ownerDocument : (
      // $FlowFixMe[prop-missing]
      e.document
    )) || window.document).documentElement;
  }
  function we(e) {
    return N(e) === "html" ? e : (
      // this is a quicker (but less type safe) way to save quite some bytes from the bundle
      // $FlowFixMe[incompatible-return]
      // $FlowFixMe[prop-missing]
      e.assignedSlot || // step into the shadow DOM of the parent of a slotted node
      e.parentNode || // DOM Element detected
      (Re(e) ? e.host : null) || // ShadowRoot detected
      // $FlowFixMe[incompatible-call]: HTMLElement is a Node
      F(e)
    );
  }
  function Je(e) {
    return !T(e) || // https://github.com/popperjs/popper-core/issues/837
    I(e).position === "fixed" ? null : e.offsetParent;
  }
  function Jt(e) {
    var t = /firefox/i.test(Le()), r2 = /Trident/i.test(Le());
    if (r2 && T(e)) {
      var i2 = I(e);
      if (i2.position === "fixed")
        return null;
    }
    var n = we(e);
    for (Re(n) && (n = n.host); T(n) && ["html", "body"].indexOf(N(n)) < 0; ) {
      var o2 = I(n);
      if (o2.transform !== "none" || o2.perspective !== "none" || o2.contain === "paint" || ["transform", "perspective"].indexOf(o2.willChange) !== -1 || t && o2.willChange === "filter" || t && o2.filter && o2.filter !== "none")
        return n;
      n = n.parentNode;
    }
    return null;
  }
  function fe(e) {
    for (var t = B(e), r2 = Je(e); r2 && Gt(r2) && I(r2).position === "static"; )
      r2 = Je(r2);
    return r2 && (N(r2) === "html" || N(r2) === "body" && I(r2).position === "static") ? t : r2 || Jt(e) || t;
  }
  function Te(e) {
    return ["top", "bottom"].indexOf(e) >= 0 ? "x" : "y";
  }
  function oe(e, t, r2) {
    return _(e, ye(t, r2));
  }
  function Qt(e, t, r2) {
    var i2 = oe(e, t, r2);
    return i2 > r2 ? r2 : i2;
  }
  function ht() {
    return {
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    };
  }
  function gt(e) {
    return Object.assign({}, ht(), e);
  }
  function mt(e, t) {
    return t.reduce(function(r2, i2) {
      return r2[i2] = e, r2;
    }, {});
  }
  var Zt = function(t, r2) {
    return t = typeof t == "function" ? t(Object.assign({}, r2.rects, {
      placement: r2.placement
    })) : t, gt(typeof t != "number" ? t : mt(t, le));
  };
  function er(e) {
    var t, r2 = e.state, i2 = e.name, n = e.options, o2 = r2.elements.arrow, l2 = r2.modifiersData.popperOffsets, s2 = H(r2.placement), a2 = Te(s2), f2 = [D, M].indexOf(s2) >= 0, c2 = f2 ? "height" : "width";
    if (!(!o2 || !l2)) {
      var h2 = Zt(n.padding, r2), y2 = Be(o2), u2 = a2 === "y" ? k : D, b2 = a2 === "y" ? S : M, v2 = r2.rects.reference[c2] + r2.rects.reference[a2] - l2[a2] - r2.rects.popper[c2], d2 = l2[a2] - r2.rects.reference[a2], w2 = fe(o2), O2 = w2 ? a2 === "y" ? w2.clientHeight || 0 : w2.clientWidth || 0 : 0, E2 = v2 / 2 - d2 / 2, p2 = h2[u2], g2 = O2 - y2[c2] - h2[b2], m2 = O2 / 2 - y2[c2] / 2 + E2, x2 = oe(p2, m2, g2), L2 = a2;
      r2.modifiersData[i2] = (t = {}, t[L2] = x2, t.centerOffset = x2 - m2, t);
    }
  }
  function tr(e) {
    var t = e.state, r2 = e.options, i2 = r2.element, n = i2 === void 0 ? "[data-popper-arrow]" : i2;
    n != null && (typeof n == "string" && (n = t.elements.popper.querySelector(n), !n) || vt(t.elements.popper, n) && (t.elements.arrow = n));
  }
  const rr = {
    name: "arrow",
    enabled: true,
    phase: "main",
    fn: er,
    effect: tr,
    requires: ["popperOffsets"],
    requiresIfExists: ["preventOverflow"]
  };
  function te(e) {
    return e.split("-")[1];
  }
  var ir = {
    top: "auto",
    right: "auto",
    bottom: "auto",
    left: "auto"
  };
  function nr(e, t) {
    var r2 = e.x, i2 = e.y, n = t.devicePixelRatio || 1;
    return {
      x: Z(r2 * n) / n || 0,
      y: Z(i2 * n) / n || 0
    };
  }
  function Qe(e) {
    var t, r2 = e.popper, i2 = e.popperRect, n = e.placement, o2 = e.variation, l2 = e.offsets, s2 = e.position, a2 = e.gpuAcceleration, f2 = e.adaptive, c2 = e.roundOffsets, h2 = e.isFixed, y2 = l2.x, u2 = y2 === void 0 ? 0 : y2, b2 = l2.y, v2 = b2 === void 0 ? 0 : b2, d2 = typeof c2 == "function" ? c2({
      x: u2,
      y: v2
    }) : {
      x: u2,
      y: v2
    };
    u2 = d2.x, v2 = d2.y;
    var w2 = l2.hasOwnProperty("x"), O2 = l2.hasOwnProperty("y"), E2 = D, p2 = k, g2 = window;
    if (f2) {
      var m2 = fe(r2), x2 = "clientHeight", L2 = "clientWidth";
      if (m2 === B(r2) && (m2 = F(r2), I(m2).position !== "static" && s2 === "absolute" && (x2 = "scrollHeight", L2 = "scrollWidth")), m2 = m2, n === k || (n === D || n === M) && o2 === se) {
        p2 = S;
        var P2 = h2 && m2 === g2 && g2.visualViewport ? g2.visualViewport.height : (
          // $FlowFixMe[prop-missing]
          m2[x2]
        );
        v2 -= P2 - i2.height, v2 *= a2 ? 1 : -1;
      }
      if (n === D || (n === k || n === S) && o2 === se) {
        E2 = M;
        var A2 = h2 && m2 === g2 && g2.visualViewport ? g2.visualViewport.width : (
          // $FlowFixMe[prop-missing]
          m2[L2]
        );
        u2 -= A2 - i2.width, u2 *= a2 ? 1 : -1;
      }
    }
    var $2 = Object.assign({
      position: s2
    }, f2 && ir), W2 = c2 === true ? nr({
      x: u2,
      y: v2
    }, B(r2)) : {
      x: u2,
      y: v2
    };
    if (u2 = W2.x, v2 = W2.y, a2) {
      var C2;
      return Object.assign({}, $2, (C2 = {}, C2[p2] = O2 ? "0" : "", C2[E2] = w2 ? "0" : "", C2.transform = (g2.devicePixelRatio || 1) <= 1 ? "translate(" + u2 + "px, " + v2 + "px)" : "translate3d(" + u2 + "px, " + v2 + "px, 0)", C2));
    }
    return Object.assign({}, $2, (t = {}, t[p2] = O2 ? v2 + "px" : "", t[E2] = w2 ? u2 + "px" : "", t.transform = "", t));
  }
  function or(e) {
    var t = e.state, r2 = e.options, i2 = r2.gpuAcceleration, n = i2 === void 0 ? true : i2, o2 = r2.adaptive, l2 = o2 === void 0 ? true : o2, s2 = r2.roundOffsets, a2 = s2 === void 0 ? true : s2, f2 = {
      placement: H(t.placement),
      variation: te(t.placement),
      popper: t.elements.popper,
      popperRect: t.rects.popper,
      gpuAcceleration: n,
      isFixed: t.options.strategy === "fixed"
    };
    t.modifiersData.popperOffsets != null && (t.styles.popper = Object.assign({}, t.styles.popper, Qe(Object.assign({}, f2, {
      offsets: t.modifiersData.popperOffsets,
      position: t.options.strategy,
      adaptive: l2,
      roundOffsets: a2
    })))), t.modifiersData.arrow != null && (t.styles.arrow = Object.assign({}, t.styles.arrow, Qe(Object.assign({}, f2, {
      offsets: t.modifiersData.arrow,
      position: "absolute",
      adaptive: false,
      roundOffsets: a2
    })))), t.attributes.popper = Object.assign({}, t.attributes.popper, {
      "data-popper-placement": t.placement
    });
  }
  const ar = {
    name: "computeStyles",
    enabled: true,
    phase: "beforeWrite",
    fn: or,
    data: {}
  };
  var ge = {
    passive: true
  };
  function sr(e) {
    var t = e.state, r2 = e.instance, i2 = e.options, n = i2.scroll, o2 = n === void 0 ? true : n, l2 = i2.resize, s2 = l2 === void 0 ? true : l2, a2 = B(t.elements.popper), f2 = [].concat(t.scrollParents.reference, t.scrollParents.popper);
    return o2 && f2.forEach(function(c2) {
      c2.addEventListener("scroll", r2.update, ge);
    }), s2 && a2.addEventListener("resize", r2.update, ge), function() {
      o2 && f2.forEach(function(c2) {
        c2.removeEventListener("scroll", r2.update, ge);
      }), s2 && a2.removeEventListener("resize", r2.update, ge);
    };
  }
  const cr = {
    name: "eventListeners",
    enabled: true,
    phase: "write",
    fn: function() {
    },
    effect: sr,
    data: {}
  };
  var lr = {
    left: "right",
    right: "left",
    bottom: "top",
    top: "bottom"
  };
  function me(e) {
    return e.replace(/left|right|bottom|top/g, function(t) {
      return lr[t];
    });
  }
  var fr = {
    start: "end",
    end: "start"
  };
  function Ze(e) {
    return e.replace(/start|end/g, function(t) {
      return fr[t];
    });
  }
  function Se(e) {
    var t = B(e), r2 = t.pageXOffset, i2 = t.pageYOffset;
    return {
      scrollLeft: r2,
      scrollTop: i2
    };
  }
  function Me(e) {
    return ee(F(e)).left + Se(e).scrollLeft;
  }
  function ur(e, t) {
    var r2 = B(e), i2 = F(e), n = r2.visualViewport, o2 = i2.clientWidth, l2 = i2.clientHeight, s2 = 0, a2 = 0;
    if (n) {
      o2 = n.width, l2 = n.height;
      var f2 = dt();
      (f2 || !f2 && t === "fixed") && (s2 = n.offsetLeft, a2 = n.offsetTop);
    }
    return {
      width: o2,
      height: l2,
      x: s2 + Me(e),
      y: a2
    };
  }
  function pr(e) {
    var t, r2 = F(e), i2 = Se(e), n = (t = e.ownerDocument) == null ? void 0 : t.body, o2 = _(r2.scrollWidth, r2.clientWidth, n ? n.scrollWidth : 0, n ? n.clientWidth : 0), l2 = _(r2.scrollHeight, r2.clientHeight, n ? n.scrollHeight : 0, n ? n.clientHeight : 0), s2 = -i2.scrollLeft + Me(e), a2 = -i2.scrollTop;
    return I(n || r2).direction === "rtl" && (s2 += _(r2.clientWidth, n ? n.clientWidth : 0) - o2), {
      width: o2,
      height: l2,
      x: s2,
      y: a2
    };
  }
  function We(e) {
    var t = I(e), r2 = t.overflow, i2 = t.overflowX, n = t.overflowY;
    return /auto|scroll|overlay|hidden/.test(r2 + n + i2);
  }
  function yt(e) {
    return ["html", "body", "#document"].indexOf(N(e)) >= 0 ? e.ownerDocument.body : T(e) && We(e) ? e : yt(we(e));
  }
  function ae(e, t) {
    var r2;
    t === void 0 && (t = []);
    var i2 = yt(e), n = i2 === ((r2 = e.ownerDocument) == null ? void 0 : r2.body), o2 = B(i2), l2 = n ? [o2].concat(o2.visualViewport || [], We(i2) ? i2 : []) : i2, s2 = t.concat(l2);
    return n ? s2 : (
      // $FlowFixMe[incompatible-call]: isBody tells us target will be an HTMLElement here
      s2.concat(ae(we(l2)))
    );
  }
  function $e(e) {
    return Object.assign({}, e, {
      left: e.x,
      top: e.y,
      right: e.x + e.width,
      bottom: e.y + e.height
    });
  }
  function dr(e, t) {
    var r2 = ee(e, false, t === "fixed");
    return r2.top = r2.top + e.clientTop, r2.left = r2.left + e.clientLeft, r2.bottom = r2.top + e.clientHeight, r2.right = r2.left + e.clientWidth, r2.width = e.clientWidth, r2.height = e.clientHeight, r2.x = r2.left, r2.y = r2.top, r2;
  }
  function et(e, t, r2) {
    return t === ut ? $e(ur(e, r2)) : K(t) ? dr(t, r2) : $e(pr(F(e)));
  }
  function vr(e) {
    var t = ae(we(e)), r2 = ["absolute", "fixed"].indexOf(I(e).position) >= 0, i2 = r2 && T(e) ? fe(e) : e;
    return K(i2) ? t.filter(function(n) {
      return K(n) && vt(n, i2) && N(n) !== "body";
    }) : [];
  }
  function hr(e, t, r2, i2) {
    var n = t === "clippingParents" ? vr(e) : [].concat(t), o2 = [].concat(n, [r2]), l2 = o2[0], s2 = o2.reduce(function(a2, f2) {
      var c2 = et(e, f2, i2);
      return a2.top = _(c2.top, a2.top), a2.right = ye(c2.right, a2.right), a2.bottom = ye(c2.bottom, a2.bottom), a2.left = _(c2.left, a2.left), a2;
    }, et(e, l2, i2));
    return s2.width = s2.right - s2.left, s2.height = s2.bottom - s2.top, s2.x = s2.left, s2.y = s2.top, s2;
  }
  function wt(e) {
    var t = e.reference, r2 = e.element, i2 = e.placement, n = i2 ? H(i2) : null, o2 = i2 ? te(i2) : null, l2 = t.x + t.width / 2 - r2.width / 2, s2 = t.y + t.height / 2 - r2.height / 2, a2;
    switch (n) {
      case k:
        a2 = {
          x: l2,
          y: t.y - r2.height
        };
        break;
      case S:
        a2 = {
          x: l2,
          y: t.y + t.height
        };
        break;
      case M:
        a2 = {
          x: t.x + t.width,
          y: s2
        };
        break;
      case D:
        a2 = {
          x: t.x - r2.width,
          y: s2
        };
        break;
      default:
        a2 = {
          x: t.x,
          y: t.y
        };
    }
    var f2 = n ? Te(n) : null;
    if (f2 != null) {
      var c2 = f2 === "y" ? "height" : "width";
      switch (o2) {
        case Q:
          a2[f2] = a2[f2] - (t[c2] / 2 - r2[c2] / 2);
          break;
        case se:
          a2[f2] = a2[f2] + (t[c2] / 2 - r2[c2] / 2);
          break;
      }
    }
    return a2;
  }
  function ce(e, t) {
    t === void 0 && (t = {});
    var r2 = t, i2 = r2.placement, n = i2 === void 0 ? e.placement : i2, o2 = r2.strategy, l2 = o2 === void 0 ? e.strategy : o2, s2 = r2.boundary, a2 = s2 === void 0 ? Mt : s2, f2 = r2.rootBoundary, c2 = f2 === void 0 ? ut : f2, h2 = r2.elementContext, y2 = h2 === void 0 ? ne : h2, u2 = r2.altBoundary, b2 = u2 === void 0 ? false : u2, v2 = r2.padding, d2 = v2 === void 0 ? 0 : v2, w2 = gt(typeof d2 != "number" ? d2 : mt(d2, le)), O2 = y2 === ne ? Wt : ne, E2 = e.rects.popper, p2 = e.elements[b2 ? O2 : y2], g2 = hr(K(p2) ? p2 : p2.contextElement || F(e.elements.popper), a2, c2, l2), m2 = ee(e.elements.reference), x2 = wt({
      reference: m2,
      element: E2,
      strategy: "absolute",
      placement: n
    }), L2 = $e(Object.assign({}, E2, x2)), P2 = y2 === ne ? L2 : m2, A2 = {
      top: g2.top - P2.top + w2.top,
      bottom: P2.bottom - g2.bottom + w2.bottom,
      left: g2.left - P2.left + w2.left,
      right: P2.right - g2.right + w2.right
    }, $2 = e.modifiersData.offset;
    if (y2 === ne && $2) {
      var W2 = $2[n];
      Object.keys(A2).forEach(function(C2) {
        var q2 = [M, S].indexOf(C2) >= 0 ? 1 : -1, X2 = [k, S].indexOf(C2) >= 0 ? "y" : "x";
        A2[C2] += W2[X2] * q2;
      });
    }
    return A2;
  }
  function gr(e, t) {
    t === void 0 && (t = {});
    var r2 = t, i2 = r2.placement, n = r2.boundary, o2 = r2.rootBoundary, l2 = r2.padding, s2 = r2.flipVariations, a2 = r2.allowedAutoPlacements, f2 = a2 === void 0 ? pt : a2, c2 = te(i2), h2 = c2 ? s2 ? Ge : Ge.filter(function(b2) {
      return te(b2) === c2;
    }) : le, y2 = h2.filter(function(b2) {
      return f2.indexOf(b2) >= 0;
    });
    y2.length === 0 && (y2 = h2);
    var u2 = y2.reduce(function(b2, v2) {
      return b2[v2] = ce(e, {
        placement: v2,
        boundary: n,
        rootBoundary: o2,
        padding: l2
      })[H(v2)], b2;
    }, {});
    return Object.keys(u2).sort(function(b2, v2) {
      return u2[b2] - u2[v2];
    });
  }
  function mr(e) {
    if (H(e) === De)
      return [];
    var t = me(e);
    return [Ze(e), t, Ze(t)];
  }
  function yr(e) {
    var t = e.state, r2 = e.options, i2 = e.name;
    if (!t.modifiersData[i2]._skip) {
      for (var n = r2.mainAxis, o2 = n === void 0 ? true : n, l2 = r2.altAxis, s2 = l2 === void 0 ? true : l2, a2 = r2.fallbackPlacements, f2 = r2.padding, c2 = r2.boundary, h2 = r2.rootBoundary, y2 = r2.altBoundary, u2 = r2.flipVariations, b2 = u2 === void 0 ? true : u2, v2 = r2.allowedAutoPlacements, d2 = t.options.placement, w2 = H(d2), O2 = w2 === d2, E2 = a2 || (O2 || !b2 ? [me(d2)] : mr(d2)), p2 = [d2].concat(E2).reduce(function(G2, V2) {
        return G2.concat(H(V2) === De ? gr(t, {
          placement: V2,
          boundary: c2,
          rootBoundary: h2,
          padding: f2,
          flipVariations: b2,
          allowedAutoPlacements: v2
        }) : V2);
      }, []), g2 = t.rects.reference, m2 = t.rects.popper, x2 = /* @__PURE__ */ new Map(), L2 = true, P2 = p2[0], A2 = 0; A2 < p2.length; A2++) {
        var $2 = p2[A2], W2 = H($2), C2 = te($2) === Q, q2 = [k, S].indexOf(W2) >= 0, X2 = q2 ? "width" : "height", R2 = ce(t, {
          placement: $2,
          boundary: c2,
          rootBoundary: h2,
          altBoundary: y2,
          padding: f2
        }), j2 = q2 ? C2 ? M : D : C2 ? S : k;
        g2[X2] > m2[X2] && (j2 = me(j2));
        var ue = me(j2), Y2 = [];
        if (o2 && Y2.push(R2[W2] <= 0), s2 && Y2.push(R2[j2] <= 0, R2[ue] <= 0), Y2.every(function(G2) {
          return G2;
        })) {
          P2 = $2, L2 = false;
          break;
        }
        x2.set($2, Y2);
      }
      if (L2)
        for (var pe = b2 ? 3 : 1, be = function(V2) {
          var ie = p2.find(function(ve) {
            var z2 = x2.get(ve);
            if (z2)
              return z2.slice(0, V2).every(function(xe) {
                return xe;
              });
          });
          if (ie)
            return P2 = ie, "break";
        }, re = pe; re > 0; re--) {
          var de = be(re);
          if (de === "break")
            break;
        }
      t.placement !== P2 && (t.modifiersData[i2]._skip = true, t.placement = P2, t.reset = true);
    }
  }
  const wr = {
    name: "flip",
    enabled: true,
    phase: "main",
    fn: yr,
    requiresIfExists: ["offset"],
    data: {
      _skip: false
    }
  };
  function tt(e, t, r2) {
    return r2 === void 0 && (r2 = {
      x: 0,
      y: 0
    }), {
      top: e.top - t.height - r2.y,
      right: e.right - t.width + r2.x,
      bottom: e.bottom - t.height + r2.y,
      left: e.left - t.width - r2.x
    };
  }
  function rt(e) {
    return [k, M, S, D].some(function(t) {
      return e[t] >= 0;
    });
  }
  function br(e) {
    var t = e.state, r2 = e.name, i2 = t.rects.reference, n = t.rects.popper, o2 = t.modifiersData.preventOverflow, l2 = ce(t, {
      elementContext: "reference"
    }), s2 = ce(t, {
      altBoundary: true
    }), a2 = tt(l2, i2), f2 = tt(s2, n, o2), c2 = rt(a2), h2 = rt(f2);
    t.modifiersData[r2] = {
      referenceClippingOffsets: a2,
      popperEscapeOffsets: f2,
      isReferenceHidden: c2,
      hasPopperEscaped: h2
    }, t.attributes.popper = Object.assign({}, t.attributes.popper, {
      "data-popper-reference-hidden": c2,
      "data-popper-escaped": h2
    });
  }
  const xr = {
    name: "hide",
    enabled: true,
    phase: "main",
    requiresIfExists: ["preventOverflow"],
    fn: br
  };
  function Or(e, t, r2) {
    var i2 = H(e), n = [D, k].indexOf(i2) >= 0 ? -1 : 1, o2 = typeof r2 == "function" ? r2(Object.assign({}, t, {
      placement: e
    })) : r2, l2 = o2[0], s2 = o2[1];
    return l2 = l2 || 0, s2 = (s2 || 0) * n, [D, M].indexOf(i2) >= 0 ? {
      x: s2,
      y: l2
    } : {
      x: l2,
      y: s2
    };
  }
  function Er(e) {
    var t = e.state, r2 = e.options, i2 = e.name, n = r2.offset, o2 = n === void 0 ? [0, 0] : n, l2 = pt.reduce(function(c2, h2) {
      return c2[h2] = Or(h2, t.rects, o2), c2;
    }, {}), s2 = l2[t.placement], a2 = s2.x, f2 = s2.y;
    t.modifiersData.popperOffsets != null && (t.modifiersData.popperOffsets.x += a2, t.modifiersData.popperOffsets.y += f2), t.modifiersData[i2] = l2;
  }
  const Ar = {
    name: "offset",
    enabled: true,
    phase: "main",
    requires: ["popperOffsets"],
    fn: Er
  };
  function Pr(e) {
    var t = e.state, r2 = e.name;
    t.modifiersData[r2] = wt({
      reference: t.rects.reference,
      element: t.rects.popper,
      strategy: "absolute",
      placement: t.placement
    });
  }
  const Lr = {
    name: "popperOffsets",
    enabled: true,
    phase: "read",
    fn: Pr,
    data: {}
  };
  function $r(e) {
    return e === "x" ? "y" : "x";
  }
  function Cr(e) {
    var t = e.state, r2 = e.options, i2 = e.name, n = r2.mainAxis, o2 = n === void 0 ? true : n, l2 = r2.altAxis, s2 = l2 === void 0 ? false : l2, a2 = r2.boundary, f2 = r2.rootBoundary, c2 = r2.altBoundary, h2 = r2.padding, y2 = r2.tether, u2 = y2 === void 0 ? true : y2, b2 = r2.tetherOffset, v2 = b2 === void 0 ? 0 : b2, d2 = ce(t, {
      boundary: a2,
      rootBoundary: f2,
      padding: h2,
      altBoundary: c2
    }), w2 = H(t.placement), O2 = te(t.placement), E2 = !O2, p2 = Te(w2), g2 = $r(p2), m2 = t.modifiersData.popperOffsets, x2 = t.rects.reference, L2 = t.rects.popper, P2 = typeof v2 == "function" ? v2(Object.assign({}, t.rects, {
      placement: t.placement
    })) : v2, A2 = typeof P2 == "number" ? {
      mainAxis: P2,
      altAxis: P2
    } : Object.assign({
      mainAxis: 0,
      altAxis: 0
    }, P2), $2 = t.modifiersData.offset ? t.modifiersData.offset[t.placement] : null, W2 = {
      x: 0,
      y: 0
    };
    if (m2) {
      if (o2) {
        var C2, q2 = p2 === "y" ? k : D, X2 = p2 === "y" ? S : M, R2 = p2 === "y" ? "height" : "width", j2 = m2[p2], ue = j2 + d2[q2], Y2 = j2 - d2[X2], pe = u2 ? -L2[R2] / 2 : 0, be = O2 === Q ? x2[R2] : L2[R2], re = O2 === Q ? -L2[R2] : -x2[R2], de = t.elements.arrow, G2 = u2 && de ? Be(de) : {
          width: 0,
          height: 0
        }, V2 = t.modifiersData["arrow#persistent"] ? t.modifiersData["arrow#persistent"].padding : ht(), ie = V2[q2], ve = V2[X2], z2 = oe(0, x2[R2], G2[R2]), xe = E2 ? x2[R2] / 2 - pe - z2 - ie - A2.mainAxis : be - z2 - ie - A2.mainAxis, Ot = E2 ? -x2[R2] / 2 + pe + z2 + ve + A2.mainAxis : re + z2 + ve + A2.mainAxis, Oe = t.elements.arrow && fe(t.elements.arrow), Et = Oe ? p2 === "y" ? Oe.clientTop || 0 : Oe.clientLeft || 0 : 0, He = (C2 = $2 == null ? void 0 : $2[p2]) != null ? C2 : 0, At = j2 + xe - He - Et, Pt = j2 + Ot - He, Ne = oe(u2 ? ye(ue, At) : ue, j2, u2 ? _(Y2, Pt) : Y2);
        m2[p2] = Ne, W2[p2] = Ne - j2;
      }
      if (s2) {
        var Ie, Lt = p2 === "x" ? k : D, $t = p2 === "x" ? S : M, U2 = m2[g2], he = g2 === "y" ? "height" : "width", Ve = U2 + d2[Lt], Fe = U2 - d2[$t], Ee = [k, D].indexOf(w2) !== -1, qe = (Ie = $2 == null ? void 0 : $2[g2]) != null ? Ie : 0, Xe = Ee ? Ve : U2 - x2[he] - L2[he] - qe + A2.altAxis, Ye = Ee ? U2 + x2[he] + L2[he] - qe - A2.altAxis : Fe, ze = u2 && Ee ? Qt(Xe, U2, Ye) : oe(u2 ? Xe : Ve, U2, u2 ? Ye : Fe);
        m2[g2] = ze, W2[g2] = ze - U2;
      }
      t.modifiersData[i2] = W2;
    }
  }
  const kr = {
    name: "preventOverflow",
    enabled: true,
    phase: "main",
    fn: Cr,
    requiresIfExists: ["offset"]
  };
  function Dr(e) {
    return {
      scrollLeft: e.scrollLeft,
      scrollTop: e.scrollTop
    };
  }
  function Rr(e) {
    return e === B(e) || !T(e) ? Se(e) : Dr(e);
  }
  function Br(e) {
    var t = e.getBoundingClientRect(), r2 = Z(t.width) / e.offsetWidth || 1, i2 = Z(t.height) / e.offsetHeight || 1;
    return r2 !== 1 || i2 !== 1;
  }
  function Tr(e, t, r2) {
    r2 === void 0 && (r2 = false);
    var i2 = T(t), n = T(t) && Br(t), o2 = F(t), l2 = ee(e, n, r2), s2 = {
      scrollLeft: 0,
      scrollTop: 0
    }, a2 = {
      x: 0,
      y: 0
    };
    return (i2 || !i2 && !r2) && ((N(t) !== "body" || // https://github.com/popperjs/popper-core/issues/1078
    We(o2)) && (s2 = Rr(t)), T(t) ? (a2 = ee(t, true), a2.x += t.clientLeft, a2.y += t.clientTop) : o2 && (a2.x = Me(o2))), {
      x: l2.left + s2.scrollLeft - a2.x,
      y: l2.top + s2.scrollTop - a2.y,
      width: l2.width,
      height: l2.height
    };
  }
  function Sr(e) {
    var t = /* @__PURE__ */ new Map(), r2 = /* @__PURE__ */ new Set(), i2 = [];
    e.forEach(function(o2) {
      t.set(o2.name, o2);
    });
    function n(o2) {
      r2.add(o2.name);
      var l2 = [].concat(o2.requires || [], o2.requiresIfExists || []);
      l2.forEach(function(s2) {
        if (!r2.has(s2)) {
          var a2 = t.get(s2);
          a2 && n(a2);
        }
      }), i2.push(o2);
    }
    return e.forEach(function(o2) {
      r2.has(o2.name) || n(o2);
    }), i2;
  }
  function Mr(e) {
    var t = Sr(e);
    return zt.reduce(function(r2, i2) {
      return r2.concat(t.filter(function(n) {
        return n.phase === i2;
      }));
    }, []);
  }
  function Wr(e) {
    var t;
    return function() {
      return t || (t = new Promise(function(r2) {
        Promise.resolve().then(function() {
          t = void 0, r2(e());
        });
      })), t;
    };
  }
  function jr(e) {
    var t = e.reduce(function(r2, i2) {
      var n = r2[i2.name];
      return r2[i2.name] = n ? Object.assign({}, n, i2, {
        options: Object.assign({}, n.options, i2.options),
        data: Object.assign({}, n.data, i2.data)
      }) : i2, r2;
    }, {});
    return Object.keys(t).map(function(r2) {
      return t[r2];
    });
  }
  var it = {
    placement: "bottom",
    modifiers: [],
    strategy: "absolute"
  };
  function nt() {
    for (var e = arguments.length, t = new Array(e), r2 = 0; r2 < e; r2++)
      t[r2] = arguments[r2];
    return !t.some(function(i2) {
      return !(i2 && typeof i2.getBoundingClientRect == "function");
    });
  }
  function Hr(e) {
    e === void 0 && (e = {});
    var t = e, r2 = t.defaultModifiers, i2 = r2 === void 0 ? [] : r2, n = t.defaultOptions, o2 = n === void 0 ? it : n;
    return function(s2, a2, f2) {
      f2 === void 0 && (f2 = o2);
      var c2 = {
        placement: "bottom",
        orderedModifiers: [],
        options: Object.assign({}, it, o2),
        modifiersData: {},
        elements: {
          reference: s2,
          popper: a2
        },
        attributes: {},
        styles: {}
      }, h2 = [], y2 = false, u2 = {
        state: c2,
        setOptions: function(w2) {
          var O2 = typeof w2 == "function" ? w2(c2.options) : w2;
          v2(), c2.options = Object.assign({}, o2, c2.options, O2), c2.scrollParents = {
            reference: K(s2) ? ae(s2) : s2.contextElement ? ae(s2.contextElement) : [],
            popper: ae(a2)
          };
          var E2 = Mr(jr([].concat(i2, c2.options.modifiers)));
          return c2.orderedModifiers = E2.filter(function(p2) {
            return p2.enabled;
          }), b2(), u2.update();
        },
        // Sync update – it will always be executed, even if not necessary. This
        // is useful for low frequency updates where sync behavior simplifies the
        // logic.
        // For high frequency updates (e.g. `resize` and `scroll` events), always
        // prefer the async Popper#update method
        forceUpdate: function() {
          if (!y2) {
            var w2 = c2.elements, O2 = w2.reference, E2 = w2.popper;
            if (nt(O2, E2)) {
              c2.rects = {
                reference: Tr(O2, fe(E2), c2.options.strategy === "fixed"),
                popper: Be(E2)
              }, c2.reset = false, c2.placement = c2.options.placement, c2.orderedModifiers.forEach(function(A2) {
                return c2.modifiersData[A2.name] = Object.assign({}, A2.data);
              });
              for (var p2 = 0; p2 < c2.orderedModifiers.length; p2++) {
                if (c2.reset === true) {
                  c2.reset = false, p2 = -1;
                  continue;
                }
                var g2 = c2.orderedModifiers[p2], m2 = g2.fn, x2 = g2.options, L2 = x2 === void 0 ? {} : x2, P2 = g2.name;
                typeof m2 == "function" && (c2 = m2({
                  state: c2,
                  options: L2,
                  name: P2,
                  instance: u2
                }) || c2);
              }
            }
          }
        },
        // Async and optimistically optimized update – it will not be executed if
        // not necessary (debounced to run at most once-per-tick)
        update: Wr(function() {
          return new Promise(function(d2) {
            u2.forceUpdate(), d2(c2);
          });
        }),
        destroy: function() {
          v2(), y2 = true;
        }
      };
      if (!nt(s2, a2))
        return u2;
      u2.setOptions(f2).then(function(d2) {
        !y2 && f2.onFirstUpdate && f2.onFirstUpdate(d2);
      });
      function b2() {
        c2.orderedModifiers.forEach(function(d2) {
          var w2 = d2.name, O2 = d2.options, E2 = O2 === void 0 ? {} : O2, p2 = d2.effect;
          if (typeof p2 == "function") {
            var g2 = p2({
              state: c2,
              name: w2,
              instance: u2,
              options: E2
            }), m2 = function() {
            };
            h2.push(g2 || m2);
          }
        });
      }
      function v2() {
        h2.forEach(function(d2) {
          return d2();
        }), h2 = [];
      }
      return u2;
    };
  }
  var Nr = [cr, Lr, ar, Kt, Ar, wr, kr, rr, xr], Ir = /* @__PURE__ */ Hr({
    defaultModifiers: Nr
  });
  async function Ce(e) {
    if (!e)
      return this.collection;
    const t = this.collection.findIndex((r2) => r2.id === e.id);
    if (t >= 0) {
      const r2 = this.collection[t];
      r2.state === "opened" && r2.close(), r2.popper.destroy(), bt(r2), Object.getOwnPropertyNames(r2).forEach((i2) => {
        delete r2[i2];
      }), this.collection.splice(t, 1);
    }
    return this.collection;
  }
  function bt(e) {
    return e.__eventListeners && (e.__eventListeners.forEach((t) => {
      t.el.forEach((r2) => {
        t.type.forEach((i2) => {
          e[r2].removeEventListener(i2, t.listener, false);
        });
      });
    }), delete e.__eventListeners), e;
  }
  async function je(e) {
    const t = at.call(this, e);
    return t.el.classList.add(this.settings.stateActive), t.trigger.hasAttribute("aria-controls") && t.trigger.setAttribute("aria-expanded", "true"), t.config = ot(t.el, this.settings), t.popper.setOptions({
      placement: t.config.placement,
      modifiers: [
        { name: "eventListeners", enabled: true },
        ...Rt(t.config)
      ]
    }), t.popper.update(), t.state = "opened", t;
  }
  async function Vr(e, t) {
    Ce.call(this, e);
    const r2 = this, i2 = {
      open() {
        return je.call(r2, this);
      },
      close() {
        return ke.call(r2, this);
      },
      deregister() {
        return Ce.call(r2, this);
      }
    }, n = {
      id: e.id,
      state: "closed",
      el: e,
      trigger: t,
      popper: Ir(t, e),
      config: ot(e, this.settings),
      ...i2
    };
    return n.trigger.hasAttribute("aria-controls") && n.trigger.setAttribute("aria-expanded", "false"), xt.call(this, n), this.collection.push(n), n.el.classList.contains(this.settings.stateActive) && (await n.open(), ft.call(this, n)), n;
  }
  function xt(e) {
    return e.__eventListeners || (e.config.event === "hover" ? (e.__eventListeners = [{
      el: ["trigger"],
      type: ["mouseenter", "focus"],
      listener: je.bind(this, e)
    }, {
      el: ["el", "trigger"],
      type: ["mouseleave", "focusout"],
      listener: lt.bind(this, e)
    }], e.__eventListeners.forEach((r2) => {
      r2.el.forEach((i2) => {
        r2.type.forEach((n) => {
          e[i2].addEventListener(n, r2.listener, false);
        });
      });
    })) : (e.__eventListeners = [{
      el: ["trigger"],
      type: ["click"],
      listener: Tt.bind(this, e)
    }], e.__eventListeners.forEach((r2) => {
      r2.el.forEach((i2) => {
        r2.type.forEach((n) => {
          e[i2].addEventListener(n, r2.listener, false);
        });
      });
    }))), e;
  }
  var J;
  class qr extends Ct {
    constructor(r2) {
      super();
      _e(this, J, void 0);
      this.defaults = Dt, this.settings = { ...this.defaults, ...r2 }, this.trigger = null, Ke(this, J, St.bind(this)), this.settings.autoInit && this.init();
    }
    async init(r2) {
      r2 && (this.settings = { ...this.settings, ...r2 });
      const i2 = document.querySelectorAll(this.settings.selectorPopover);
      return await this.registerCollection(i2), this.settings.eventListeners && this.initEventListeners(false), this;
    }
    async destroy() {
      return this.trigger = null, await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(false), this;
    }
    initEventListeners(r2 = true) {
      r2 && this.collection.forEach((i2) => {
        xt.call(this, i2);
      }), document.addEventListener("keydown", Ae(this, J), false);
    }
    destroyEventListeners(r2 = true) {
      r2 && this.collection.forEach((i2) => {
        bt(i2);
      }), document.removeEventListener("keydown", Ae(this, J), false);
    }
    register(r2) {
      const i2 = Bt.call(this, r2);
      return i2.error ? Promise.reject(i2.error) : Vr.call(this, i2.popover, i2.trigger);
    }
    deregister(r2) {
      const i2 = this.get(st.call(this, r2));
      return Ce.call(this, i2);
    }
    open(r2) {
      return je.call(this, r2);
    }
    close(r2) {
      return ke.call(this, r2);
    }
  }
  J = /* @__PURE__ */ new WeakMap();
  exports2.Checkbox = r$1;
  exports2.Drawer = it$1;
  exports2.Modal = U;
  exports2.Popover = qr;
  exports2.core = index;
  Object.defineProperty(exports2, Symbol.toStringTag, { value: "Module" });
});
//# sourceMappingURL=index.umd.cjs.map
