var Ke = (e, t, i) => {
  if (!t.has(e))
    throw TypeError("Cannot " + i);
}, S = (e, t, i) => (Ke(e, t, "read from private field"), i ? i.call(e) : t.get(e)), Rt = (e, t, i) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, i);
}, it = (e, t, i, n) => (Ke(e, t, "write to private field"), n ? n.call(e, i) : t.set(e, i), i), P;
let Ai = class {
  constructor(t, i) {
    Rt(this, P, void 0), this.value = t, it(this, P, i), this.mql = null;
  }
  get handler() {
    return S(this, P);
  }
  // Unmount existing handler before setting a new one.
  set handler(t) {
    this.mql && (typeof this.mql.removeEventListener == "function" ? this.mql.removeEventListener("change", S(this, P)) : this.mql.removeListener(S(this, P))), it(this, P, t);
  }
  mount(t, i) {
    return t && (this.value = t), i && it(this, P, i), this.value ? (this.mql = window.matchMedia(`(min-width: ${this.value})`), typeof this.mql.addEventListener == "function" ? this.mql.addEventListener("change", S(this, P)) : this.mql.addListener(S(this, P)), S(this, P).call(this, this.mql), this) : this;
  }
  unmount() {
    return this.mql ? (typeof this.mql.removeEventListener == "function" ? this.mql.removeEventListener("change", S(this, P)) : this.mql.removeListener(S(this, P)), this.value = null, it(this, P, null), this.mql = null, this) : this;
  }
};
P = /* @__PURE__ */ new WeakMap();
let Ci = class {
  constructor() {
    this.collection = [];
  }
  async register(t) {
    return await this.deregister(t), this.collection.push(t), this.collection;
  }
  async deregister(t) {
    const i = this.collection.findIndex((n) => n === t);
    if (i >= 0) {
      const n = this.collection[i];
      Object.getOwnPropertyNames(n).forEach((s) => {
        delete n[s];
      }), this.collection.splice(i, 1);
    }
    return this.collection;
  }
  async registerCollection(t) {
    return await Promise.all(Array.from(t, (i) => {
      this.register(i);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(t, i = "id") {
    return this.collection.find((n) => n[i] === t);
  }
};
const p = {
  inert: ":not([inert]):not([inert] *)",
  negTabIndex: ':not([tabindex^="-"])',
  disabled: ":not(:disabled)"
}, Ii = [
  `a[href]${p.inert}${p.negTabIndex}`,
  `area[href]${p.inert}${p.negTabIndex}`,
  `input:not([type="hidden"]):not([type="radio"])${p.inert}${p.negTabIndex}${p.disabled}`,
  `input[type="radio"]${p.inert}${p.negTabIndex}${p.disabled}`,
  `select${p.inert}${p.negTabIndex}${p.disabled}`,
  `textarea${p.inert}${p.negTabIndex}${p.disabled}`,
  `button${p.inert}${p.negTabIndex}${p.disabled}`,
  `details${p.inert} > summary:first-of-type${p.negTabIndex}`,
  // Discard until Firefox supports `:has()`
  // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
  // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
  `iframe${p.inert}${p.negTabIndex}`,
  `audio[controls]${p.inert}${p.negTabIndex}`,
  `video[controls]${p.inert}${p.negTabIndex}`,
  `[contenteditable]${p.inert}${p.negTabIndex}`,
  `[tabindex]${p.inert}${p.negTabIndex}`
];
var wt, at, lt;
let Si = class {
  constructor(t = null, i = "[data-focus]") {
    Rt(this, wt, void 0), Rt(this, at, void 0), Rt(this, lt, void 0), this.el = t, this.selectorFocus = i, it(this, at, qi.bind(this)), it(this, lt, Di.bind(this));
  }
  get focusable() {
    return S(this, wt);
  }
  set focusable(t) {
    it(this, wt, t), S(this, wt).length ? (document.removeEventListener("keydown", S(this, lt)), document.addEventListener("keydown", S(this, at))) : (document.removeEventListener("keydown", S(this, at)), document.addEventListener("keydown", S(this, lt)));
  }
  get focusableFirst() {
    return this.focusable[0];
  }
  get focusableLast() {
    return this.focusable[this.focusable.length - 1];
  }
  mount(t, i) {
    t && (this.el = t), i && (this.selectorFocus = i), this.focusable = this.getFocusable(), this.focus();
  }
  unmount() {
    this.el = null, this.focusable = [], document.removeEventListener("keydown", S(this, at)), document.removeEventListener("keydown", S(this, lt));
  }
  focus(t = this.el, i = this.selectorFocus) {
    (t.querySelector(i) || t).focus();
  }
  getFocusable(t = this.el) {
    const i = [], n = document.activeElement, s = t.scrollTop;
    return t.querySelectorAll(Ii.join(",")).forEach((r) => {
      r.focus(), document.activeElement === r && i.push(r);
    }), t.scrollTop = s, n.focus(), i;
  }
};
wt = /* @__PURE__ */ new WeakMap(), at = /* @__PURE__ */ new WeakMap(), lt = /* @__PURE__ */ new WeakMap();
function qi(e) {
  (e.key === "Tab" || e.keyCode === 9) && (e.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (e.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (e.preventDefault(), this.focusableFirst.focus()));
}
function Di(e) {
  (e.key === "Tab" || e.keyCode === 9) && e.preventDefault();
}
function Pi(e, t) {
  const i = (e.getAttribute(`data-${t}`) || "").replace(/'/g, '"');
  return i ? JSON.parse(i) : {};
}
function Mi() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-variable-prefix").trim();
}
function Wi(e, t = !0) {
  const i = localStorage.getItem(e), n = i ? JSON.parse(i) : {};
  return {
    get(s) {
      return s ? n[s] : n;
    },
    set(s, r) {
      return r ? n[s] = r : delete n[s], t && localStorage.setItem(e, JSON.stringify(n)), n;
    }
  };
}
function ji(e, t, i) {
  const n = t.nodeType === Node.COMMENT_NODE, s = t.nodeType === Node.ELEMENT_NODE;
  if (t = n || s ? t : document.querySelector(t), n && (i = "after"), !t)
    throw new Error(`Not a valid teleport reference: '${t}'`);
  if (typeof t[i] != "function")
    throw new Error(`Not a valid teleport method: '${i}'`);
  let r = null;
  return n || (r = document.createComment("teleported #" + e.id), e.before(r)), t[i](e), n && t.remove(), r;
}
const Ni = (e, t) => new Promise((i) => {
  t.transition ? (e.classList.remove(t.stateClosed), e.classList.add(t.stateOpening), e.addEventListener("transitionend", function n() {
    e.classList.add(t.stateOpened), e.classList.remove(t.stateOpening), i(e), this.removeEventListener("transitionend", n);
  })) : (e.classList.add(t.stateOpened), e.classList.remove(t.stateClosed), i(e));
}), _i = (e, t) => new Promise((i) => {
  t.transition ? (e.classList.add(t.stateClosing), e.classList.remove(t.stateOpened), e.addEventListener("transitionend", function n() {
    e.classList.remove(t.stateClosing), e.classList.add(t.stateClosed), i(e), this.removeEventListener("transitionend", n);
  })) : (e.classList.add(t.stateClosed), e.classList.remove(t.stateOpened), i(e));
});
function Fi(e, t) {
  t && document.querySelectorAll(t).forEach((i) => {
    e ? i.style.overflow = "hidden" : i.style.removeProperty("overflow");
  });
}
function Bi(e, t) {
  t && document.querySelectorAll(t).forEach((i) => {
    e ? (i.inert = !0, i.setAttribute("aria-hidden", !0)) : (i.inert = null, i.removeAttribute("aria-hidden"));
  });
}
function Ri(e, t) {
  Bi(!!e, t.selectorInert), Fi(!!e, t.selectorOverflow);
}
const Qs = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  Breakpoint: Ai,
  Collection: Ci,
  FocusTrap: Si,
  closeTransition: _i,
  getConfig: Pi,
  getPrefix: Mi,
  localStore: Wi,
  openTransition: Ni,
  teleport: ji,
  updateGlobalState: Ri
}, Symbol.toStringTag, { value: "Module" })), Hi = {
  autoInit: !1,
  stateAttr: "aria-checked",
  stateValue: "mixed"
};
let Zs = class {
  constructor(t) {
    this.defaults = Hi, this.settings = { ...this.defaults, ...t }, this.__handlerClick = this.handlerClick.bind(this), this.settings.autoInit && this.init();
  }
  init(t = null) {
    t && (this.settings = { ...this.settings, ...t });
    const i = `[${this.settings.stateAttr}="${this.settings.stateValue}"]`, n = document.querySelectorAll(i);
    this.setIndeterminate(n), document.addEventListener("click", this.__handlerClick, !1);
  }
  destroy() {
    document.removeEventListener("click", this.__handlerClick, !1);
  }
  handlerClick(t) {
    const i = `[${this.settings.stateAttr}="${this.settings.stateValue}"]`, n = t.target.closest(i);
    n && (this.removeAriaState(n), this.setIndeterminate(n));
  }
  setAriaState(t, i = this.settings.stateValue) {
    t = t.forEach ? t : [t], t.forEach((n) => {
      n.setAttribute(this.settings.stateAttr, i);
    });
  }
  removeAriaState(t) {
    t = t.forEach ? t : [t], t.forEach((i) => {
      i.removeAttribute(this.settings.stateAttr);
    });
  }
  setIndeterminate(t) {
    t = t.forEach ? t : [t], t.forEach((i) => {
      i.hasAttribute(this.settings.stateAttr) ? i.indeterminate = !0 : i.indeterminate = !1;
    });
  }
};
var Ge = (e, t, i) => {
  if (!t.has(e))
    throw TypeError("Cannot " + i);
}, _t = (e, t, i) => (Ge(e, t, "read from private field"), i ? i.call(e) : t.get(e)), qe = (e, t, i) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, i);
}, De = (e, t, i, n) => (Ge(e, t, "write to private field"), n ? n.call(e, i) : t.set(e, i), i), Qe = (e, t, i) => {
  if (!t.has(e))
    throw TypeError("Cannot " + i);
}, q = (e, t, i) => (Qe(e, t, "read from private field"), i ? i.call(e) : t.get(e)), Ht = (e, t, i) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, i);
}, nt = (e, t, i, n) => (Qe(e, t, "write to private field"), n ? n.call(e, i) : t.set(e, i), i), M;
let Vi = class {
  constructor(t, i) {
    Ht(this, M, void 0), this.value = t, nt(this, M, i), this.mql = null;
  }
  get handler() {
    return q(this, M);
  }
  // Unmount existing handler before setting a new one.
  set handler(t) {
    this.mql && (typeof this.mql.removeEventListener == "function" ? this.mql.removeEventListener("change", q(this, M)) : this.mql.removeListener(q(this, M))), nt(this, M, t);
  }
  mount(t, i) {
    return t && (this.value = t), i && nt(this, M, i), this.value ? (this.mql = window.matchMedia(`(min-width: ${this.value})`), typeof this.mql.addEventListener == "function" ? this.mql.addEventListener("change", q(this, M)) : this.mql.addListener(q(this, M)), q(this, M).call(this, this.mql), this) : this;
  }
  unmount() {
    return this.mql ? (typeof this.mql.removeEventListener == "function" ? this.mql.removeEventListener("change", q(this, M)) : this.mql.removeListener(q(this, M)), this.value = null, nt(this, M, null), this.mql = null, this) : this;
  }
};
M = /* @__PURE__ */ new WeakMap();
let Ji = class {
  constructor() {
    this.collection = [];
  }
  async register(t) {
    return await this.deregister(t), this.collection.push(t), this.collection;
  }
  async deregister(t) {
    const i = this.collection.findIndex((n) => n === t);
    if (i >= 0) {
      const n = this.collection[i];
      Object.getOwnPropertyNames(n).forEach((s) => {
        delete n[s];
      }), this.collection.splice(i, 1);
    }
    return this.collection;
  }
  async registerCollection(t) {
    return await Promise.all(Array.from(t, (i) => {
      this.register(i);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(t, i = "id") {
    return this.collection.find((n) => n[i] === t);
  }
};
const g = {
  inert: ":not([inert]):not([inert] *)",
  negTabIndex: ':not([tabindex^="-"])',
  disabled: ":not(:disabled)"
}, zi = [
  `a[href]${g.inert}${g.negTabIndex}`,
  `area[href]${g.inert}${g.negTabIndex}`,
  `input:not([type="hidden"]):not([type="radio"])${g.inert}${g.negTabIndex}${g.disabled}`,
  `input[type="radio"]${g.inert}${g.negTabIndex}${g.disabled}`,
  `select${g.inert}${g.negTabIndex}${g.disabled}`,
  `textarea${g.inert}${g.negTabIndex}${g.disabled}`,
  `button${g.inert}${g.negTabIndex}${g.disabled}`,
  `details${g.inert} > summary:first-of-type${g.negTabIndex}`,
  // Discard until Firefox supports `:has()`
  // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
  // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
  `iframe${g.inert}${g.negTabIndex}`,
  `audio[controls]${g.inert}${g.negTabIndex}`,
  `video[controls]${g.inert}${g.negTabIndex}`,
  `[contenteditable]${g.inert}${g.negTabIndex}`,
  `[tabindex]${g.inert}${g.negTabIndex}`
];
var $t, ct, dt;
let Ki = class {
  constructor(t = null, i = "[data-focus]") {
    Ht(this, $t, void 0), Ht(this, ct, void 0), Ht(this, dt, void 0), this.el = t, this.selectorFocus = i, nt(this, ct, Gi.bind(this)), nt(this, dt, Qi.bind(this));
  }
  get focusable() {
    return q(this, $t);
  }
  set focusable(t) {
    nt(this, $t, t), q(this, $t).length ? (document.removeEventListener("keydown", q(this, dt)), document.addEventListener("keydown", q(this, ct))) : (document.removeEventListener("keydown", q(this, ct)), document.addEventListener("keydown", q(this, dt)));
  }
  get focusableFirst() {
    return this.focusable[0];
  }
  get focusableLast() {
    return this.focusable[this.focusable.length - 1];
  }
  mount(t, i) {
    t && (this.el = t), i && (this.selectorFocus = i), this.focusable = this.getFocusable(), this.focus();
  }
  unmount() {
    this.el = null, this.focusable = [], document.removeEventListener("keydown", q(this, ct)), document.removeEventListener("keydown", q(this, dt));
  }
  focus(t = this.el, i = this.selectorFocus) {
    (t.querySelector(i) || t).focus();
  }
  getFocusable(t = this.el) {
    const i = [], n = document.activeElement, s = t.scrollTop;
    return t.querySelectorAll(zi.join(",")).forEach((r) => {
      r.focus(), document.activeElement === r && i.push(r);
    }), t.scrollTop = s, n.focus(), i;
  }
};
$t = /* @__PURE__ */ new WeakMap(), ct = /* @__PURE__ */ new WeakMap(), dt = /* @__PURE__ */ new WeakMap();
function Gi(e) {
  (e.key === "Tab" || e.keyCode === 9) && (e.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (e.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (e.preventDefault(), this.focusableFirst.focus()));
}
function Qi(e) {
  (e.key === "Tab" || e.keyCode === 9) && e.preventDefault();
}
function Zi(e, t) {
  const i = (e.getAttribute(`data-${t}`) || "").replace(/'/g, '"');
  return i ? JSON.parse(i) : {};
}
function Ui() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-variable-prefix").trim();
}
function Xi(e, t = !0) {
  const i = localStorage.getItem(e), n = i ? JSON.parse(i) : {};
  return {
    get(s) {
      return s ? n[s] : n;
    },
    set(s, r) {
      return r ? n[s] = r : delete n[s], t && localStorage.setItem(e, JSON.stringify(n)), n;
    }
  };
}
const Yi = (e, t) => new Promise((i) => {
  t.transition ? (e.classList.remove(t.stateClosed), e.classList.add(t.stateOpening), e.addEventListener("transitionend", function n() {
    e.classList.add(t.stateOpened), e.classList.remove(t.stateOpening), i(e), this.removeEventListener("transitionend", n);
  })) : (e.classList.add(t.stateOpened), e.classList.remove(t.stateClosed), i(e));
}), tn = (e, t) => new Promise((i) => {
  t.transition ? (e.classList.add(t.stateClosing), e.classList.remove(t.stateOpened), e.addEventListener("transitionend", function n() {
    e.classList.remove(t.stateClosing), e.classList.add(t.stateClosed), i(e), this.removeEventListener("transitionend", n);
  })) : (e.classList.add(t.stateClosed), e.classList.remove(t.stateOpened), i(e));
});
function en(e, t) {
  t && document.querySelectorAll(t).forEach((i) => {
    e ? i.style.overflow = "hidden" : i.style.removeProperty("overflow");
  });
}
function nn(e, t) {
  t && document.querySelectorAll(t).forEach((i) => {
    e ? (i.inert = !0, i.setAttribute("aria-hidden", !0)) : (i.inert = null, i.removeAttribute("aria-hidden"));
  });
}
function le(e, t) {
  nn(!!e, t.selectorInert), en(!!e, t.selectorOverflow);
}
const sn = {
  autoInit: !1,
  // Data attributes
  dataOpen: "drawer-open",
  dataClose: "drawer-close",
  dataToggle: "drawer-toggle",
  dataBreakpoint: "drawer-breakpoint",
  dataConfig: "drawer-config",
  // Selectors
  selectorDrawer: ".drawer",
  selectorDialog: ".drawer__dialog",
  selectorFocus: "[data-focus]",
  selectorInert: null,
  selectorOverflow: "body",
  // State classes
  stateOpened: "is-opened",
  stateOpening: "is-opening",
  stateClosing: "is-closing",
  stateClosed: "is-closed",
  // Classes
  classModal: "drawer_modal",
  // Feature toggles
  breakpoints: null,
  customEventPrefix: "drawer:",
  eventListeners: !0,
  store: !0,
  storeKey: "VB:DrawerState",
  setTabindex: !0,
  transition: !0
};
function rn(e) {
  const t = e.target.closest(`
    [data-${this.settings.dataOpen}],
    [data-${this.settings.dataToggle}],
    [data-${this.settings.dataClose}]
  `);
  if (t) {
    e.preventDefault(), t.matches(`[data-${this.settings.dataToggle}]`) && t.getAttribute(`data-${this.settings.dataToggle}`).trim().split(" ").forEach((i) => {
      const n = this.get(i);
      n.trigger = t, n.toggle();
    }), t.matches(`[data-${this.settings.dataOpen}]`) && t.getAttribute(`data-${this.settings.dataOpen}`).trim().split(" ").forEach((i) => {
      const n = this.get(i);
      n.trigger = t, n.open();
    }), t.matches(`[data-${this.settings.dataClose}]`) && t.getAttribute(`data-${this.settings.dataClose}`).trim().split(" ").forEach((i) => {
      if (i) {
        const n = this.get(i);
        n.trigger = t, n.close();
      } else {
        const n = e.target.closest(this.settings.selectorDrawer);
        n && this.close(n);
      }
    });
    return;
  }
  e.target.matches(this.settings.selectorDrawer) && this.close(e.target.id);
}
function on(e) {
  if (e.key === "Escape") {
    const t = this.activeModal;
    t && this.close(t);
  }
}
async function ie(e, t = !0) {
  if (!e)
    return this.collection;
  const i = this.collection.findIndex((n) => n.id === e.id);
  if (i >= 0) {
    const n = this.collection[i];
    t && n.state === "opened" && await n.close(!1), this.store.set(n.id), n.unmountBreakpoint(), Object.getOwnPropertyNames(n).forEach((s) => {
      delete n[s];
    }), this.collection.splice(i, 1);
  }
  return this.collection;
}
function an(e) {
  const t = Ui(), i = e.getAttribute(`data-${this.settings.dataBreakpoint}`);
  return this.settings.breakpoints && this.settings.breakpoints[i] ? this.settings.breakpoints[i] : getComputedStyle(document.body).getPropertyValue(`--${t}breakpoint-${i}`).trim() ? getComputedStyle(document.body).getPropertyValue(`--${t}breakpoint-${i}`).trim() : i;
}
function ce(e) {
  const t = typeof e == "string" ? this.get(e) : this.get(e.id);
  if (t)
    return t;
  throw new Error(`Drawer not found in collection with id of "${e.id || e}".`);
}
function Ze(e) {
  return typeof e == "string" ? e : typeof e.hasAttribute == "function" ? e.hasAttribute(`data-${this.settings.dataOpen}`) ? e.getAttribute(`data-${this.settings.dataOpen}`) : e.hasAttribute(`data-${this.settings.dataClose}`) ? e.getAttribute(`data-${this.settings.dataClose}`) || !1 : e.hasAttribute(`data-${this.settings.dataToggle}`) ? e.getAttribute(`data-${this.settings.dataToggle}`) : e.closest(this.settings.selectorDrawer) ? (e = e.closest(this.settings.selectorDrawer), e.id || !1) : !1 : e.id ? e.id : !1;
}
function ln(e) {
  const t = Ze.call(this, e);
  if (t) {
    const i = document.querySelector(`#${t}`), n = i ? i.querySelector(this.settings.selectorDialog) : null;
    return !i && !n ? { error: new Error(`No drawer elements found using the ID: "${t}".`) } : n ? { drawer: i, dialog: n } : { error: new Error("Drawer is missing dialog element.") };
  } else
    return { error: new Error("Could not resolve the drawer ID.") };
}
async function Ue(e) {
  this.store.get(e.id) ? this.store.get(e.id) === "opened" ? await e.open(!1, !1) : await e.close(!1, !1) : e.el.classList.contains(this.settings.stateOpened) ? e.state = "opened" : (e.el.classList.remove(this.settings.stateOpening), e.el.classList.remove(this.settings.stateClosing), e.el.classList.add(this.settings.stateClosed));
}
function Xe(e) {
  e.state === "opened" ? e.mode === "modal" ? this.focusTrap.mount(e.dialog, this.settings.selectorFocus) : this.focusTrap.focus(e.dialog, this.settings.selectorFocus) : (e.trigger && (e.trigger.focus(), e.trigger = null), this.focusTrap.unmount());
}
async function de(e, t, i = !0) {
  const n = ce.call(this, e), s = { ...this.settings, ...n.settings };
  return t !== void 0 && (s.transition = t), n.state === "closed" && (n.state = "opening", await Yi(n.el, s), n.mode === "modal" && le(!0, s), n.state = "opened"), i && Xe.call(this, n), n.el.dispatchEvent(new CustomEvent(s.customEventPrefix + "opened", {
    detail: this,
    bubbles: !0
  })), n;
}
async function Kt(e, t, i = !0) {
  const n = ce.call(this, e), s = { ...this.settings, ...n.settings };
  return t !== void 0 && (s.transition = t), n.state === "opened" && (n.state = "closing", document.activeElement.blur(), await tn(n.el, s), n.mode === "modal" && le(!1, s), i && Xe.call(this, n), n.state = "closed", n.el.dispatchEvent(new CustomEvent(s.customEventPrefix + "closed", {
    detail: this,
    bubbles: !0
  }))), n;
}
async function Ye(e, t, i) {
  const n = ce.call(this, e);
  return n.state === "closed" ? de.call(this, n, t, i) : Kt.call(this, n, t, i);
}
function cn(e) {
  switch (e.mode) {
    case "inline":
      return dn.call(this, e);
    case "modal":
      return un.call(this, e);
    default:
      throw new Error(`"${e.mode}" is not a valid drawer mode.`);
  }
}
async function dn(e) {
  return e.el.classList.remove(e.getSetting("classModal")), e.dialog.removeAttribute("aria-modal"), le(!1, { ...this.settings, ...e.settings }), this.focusTrap.unmount(), await Ue.call(this, e), e.el.dispatchEvent(new CustomEvent(e.getSetting("customEventPrefix") + "switchMode", {
    detail: this,
    bubbles: !0
  })), e;
}
async function un(e) {
  return e.el.classList.add(e.getSetting("classModal")), e.dialog.setAttribute("aria-modal", "true"), !this.store.get(e.id) && e.el.classList.contains(e.getSetting("stateOpened")) && this.store.set(e.id, "opened"), await Kt.call(this, e, !1, !1), e.el.dispatchEvent(new CustomEvent(e.getSetting("customEventPrefix") + "switchMode", {
    detail: this,
    bubbles: !0
  })), e;
}
async function hn(e, t) {
  await ie.call(this, e, !1);
  const i = this, n = new Vi(), s = {
    open(o, c) {
      return de.call(i, this, o, c);
    },
    close(o, c) {
      return Kt.call(i, this, o, c);
    },
    toggle(o, c) {
      return Ye.call(i, this, o, c);
    },
    deregister() {
      return ie.call(i, this);
    },
    mountBreakpoint() {
      const o = this.breakpoint, c = this.handleBreakpoint.bind(this);
      return n.mount(o, c), this;
    },
    unmountBreakpoint() {
      return n.unmount(), this;
    },
    handleBreakpoint(o) {
      return this.mode = o.matches ? "inline" : "modal", this;
    },
    getSetting(o) {
      return o in this.settings ? this.settings[o] : i.settings[o];
    }
  }, r = {
    id: e.id,
    el: e,
    dialog: t,
    trigger: null,
    settings: Zi(e, this.settings.dataConfig),
    get breakpoint() {
      return an.call(i, e);
    },
    get state() {
      return a;
    },
    set state(o) {
      a = o, (o === "opened" || o === "closed") && this.mode === "inline" && i.store.set(this.id, this.state);
    },
    get mode() {
      return l;
    },
    set mode(o) {
      l = o, cn.call(i, this);
    },
    ...s
  };
  let a = e.classList.contains(r.getSetting("stateOpened")) ? "opened" : "closed", l = e.classList.contains(r.getSetting("classModal")) ? "modal" : "inline";
  return r.mode === "modal" ? r.dialog.setAttribute("aria-modal", "true") : r.dialog.removeAttribute("aria-modal"), r.getSetting("setTabindex") && r.dialog.setAttribute("tabindex", "-1"), this.collection.push(r), r.breakpoint ? r.mountBreakpoint() : await Ue.call(this, r), r;
}
var Et, xt;
let er = class extends Ji {
  constructor(t) {
    super(), qe(this, Et, void 0), qe(this, xt, void 0), this.defaults = sn, this.settings = { ...this.defaults, ...t }, this.focusTrap = new Ki(), this.store = Xi(this.settings.storeKey, this.settings.store), De(this, Et, rn.bind(this)), De(this, xt, on.bind(this)), this.settings.autoInit && this.init();
  }
  get activeModal() {
    return this.collection.find((t) => t.state === "opened" && t.mode === "modal");
  }
  async init(t = null) {
    t && (this.settings = { ...this.settings, ...t });
    const i = document.querySelectorAll(this.settings.selectorDrawer);
    return await this.registerCollection(i), this.settings.eventListeners && this.initEventListeners(), this;
  }
  async destroy() {
    return await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(), this;
  }
  initEventListeners() {
    document.addEventListener("click", _t(this, Et), !1), document.addEventListener("keydown", _t(this, xt), !1);
  }
  destroyEventListeners() {
    document.removeEventListener("click", _t(this, Et), !1), document.removeEventListener("keydown", _t(this, xt), !1);
  }
  register(t) {
    const i = ln.call(this, t);
    return i.error ? Promise.reject(i.error) : hn.call(this, i.drawer, i.dialog);
  }
  deregister(t) {
    const i = this.get(Ze.call(this, t));
    return ie.call(this, i);
  }
  open(t, i, n) {
    return de.call(this, t, i, n);
  }
  close(t, i, n) {
    return Kt.call(this, t, i, n);
  }
  toggle(t, i, n) {
    return Ye.call(this, t, i, n);
  }
};
Et = /* @__PURE__ */ new WeakMap(), xt = /* @__PURE__ */ new WeakMap();
var ti = (e, t, i) => {
  if (!t.has(e))
    throw TypeError("Cannot " + i);
}, Ft = (e, t, i) => (ti(e, t, "read from private field"), i ? i.call(e) : t.get(e)), Pe = (e, t, i) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, i);
}, Me = (e, t, i, n) => (ti(e, t, "write to private field"), n ? n.call(e, i) : t.set(e, i), i), ei = (e, t, i) => {
  if (!t.has(e))
    throw TypeError("Cannot " + i);
}, Q = (e, t, i) => (ei(e, t, "read from private field"), i ? i.call(e) : t.get(e)), Yt = (e, t, i) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, i);
}, te = (e, t, i, n) => (ei(e, t, "write to private field"), n ? n.call(e, i) : t.set(e, i), i);
class fn {
  constructor() {
    this.collection = [];
  }
  async register(t) {
    return await this.deregister(t), this.collection.push(t), this.collection;
  }
  async deregister(t) {
    const i = this.collection.findIndex((n) => n === t);
    if (i >= 0) {
      const n = this.collection[i];
      Object.getOwnPropertyNames(n).forEach((s) => {
        delete n[s];
      }), this.collection.splice(i, 1);
    }
    return this.collection;
  }
  async registerCollection(t) {
    return await Promise.all(Array.from(t, (i) => {
      this.register(i);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(t, i = "id") {
    return this.collection.find((n) => n[i] === t);
  }
}
const m = {
  inert: ":not([inert]):not([inert] *)",
  negTabIndex: ':not([tabindex^="-"])',
  disabled: ":not(:disabled)"
}, pn = [
  `a[href]${m.inert}${m.negTabIndex}`,
  `area[href]${m.inert}${m.negTabIndex}`,
  `input:not([type="hidden"]):not([type="radio"])${m.inert}${m.negTabIndex}${m.disabled}`,
  `input[type="radio"]${m.inert}${m.negTabIndex}${m.disabled}`,
  `select${m.inert}${m.negTabIndex}${m.disabled}`,
  `textarea${m.inert}${m.negTabIndex}${m.disabled}`,
  `button${m.inert}${m.negTabIndex}${m.disabled}`,
  `details${m.inert} > summary:first-of-type${m.negTabIndex}`,
  // Discard until Firefox supports `:has()`
  // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
  // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
  `iframe${m.inert}${m.negTabIndex}`,
  `audio[controls]${m.inert}${m.negTabIndex}`,
  `video[controls]${m.inert}${m.negTabIndex}`,
  `[contenteditable]${m.inert}${m.negTabIndex}`,
  `[tabindex]${m.inert}${m.negTabIndex}`
];
var Lt, ut, ht;
let gn = class {
  constructor(t = null, i = "[data-focus]") {
    Yt(this, Lt, void 0), Yt(this, ut, void 0), Yt(this, ht, void 0), this.el = t, this.selectorFocus = i, te(this, ut, mn.bind(this)), te(this, ht, vn.bind(this));
  }
  get focusable() {
    return Q(this, Lt);
  }
  set focusable(t) {
    te(this, Lt, t), Q(this, Lt).length ? (document.removeEventListener("keydown", Q(this, ht)), document.addEventListener("keydown", Q(this, ut))) : (document.removeEventListener("keydown", Q(this, ut)), document.addEventListener("keydown", Q(this, ht)));
  }
  get focusableFirst() {
    return this.focusable[0];
  }
  get focusableLast() {
    return this.focusable[this.focusable.length - 1];
  }
  mount(t, i) {
    t && (this.el = t), i && (this.selectorFocus = i), this.focusable = this.getFocusable(), this.focus();
  }
  unmount() {
    this.el = null, this.focusable = [], document.removeEventListener("keydown", Q(this, ut)), document.removeEventListener("keydown", Q(this, ht));
  }
  focus(t = this.el, i = this.selectorFocus) {
    (t.querySelector(i) || t).focus();
  }
  getFocusable(t = this.el) {
    const i = [], n = document.activeElement, s = t.scrollTop;
    return t.querySelectorAll(pn.join(",")).forEach((r) => {
      r.focus(), document.activeElement === r && i.push(r);
    }), t.scrollTop = s, n.focus(), i;
  }
};
Lt = /* @__PURE__ */ new WeakMap(), ut = /* @__PURE__ */ new WeakMap(), ht = /* @__PURE__ */ new WeakMap();
function mn(e) {
  (e.key === "Tab" || e.keyCode === 9) && (e.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (e.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (e.preventDefault(), this.focusableFirst.focus()));
}
function vn(e) {
  (e.key === "Tab" || e.keyCode === 9) && e.preventDefault();
}
function bn(e, t) {
  const i = (e.getAttribute(`data-${t}`) || "").replace(/'/g, '"');
  return i ? JSON.parse(i) : {};
}
function We(e, t, i) {
  const n = t.nodeType === Node.COMMENT_NODE, s = t.nodeType === Node.ELEMENT_NODE;
  if (t = n || s ? t : document.querySelector(t), n && (i = "after"), !t)
    throw new Error(`Not a valid teleport reference: '${t}'`);
  if (typeof t[i] != "function")
    throw new Error(`Not a valid teleport method: '${i}'`);
  let r = null;
  return n || (r = document.createComment("teleported #" + e.id), e.before(r)), t[i](e), n && t.remove(), r;
}
const yn = (e, t) => new Promise((i) => {
  t.transition ? (e.classList.remove(t.stateClosed), e.classList.add(t.stateOpening), e.addEventListener("transitionend", function n() {
    e.classList.add(t.stateOpened), e.classList.remove(t.stateOpening), i(e), this.removeEventListener("transitionend", n);
  })) : (e.classList.add(t.stateOpened), e.classList.remove(t.stateClosed), i(e));
}), wn = (e, t) => new Promise((i) => {
  t.transition ? (e.classList.add(t.stateClosing), e.classList.remove(t.stateOpened), e.addEventListener("transitionend", function n() {
    e.classList.remove(t.stateClosing), e.classList.add(t.stateClosed), i(e), this.removeEventListener("transitionend", n);
  })) : (e.classList.add(t.stateClosed), e.classList.remove(t.stateOpened), i(e));
});
function $n(e, t) {
  t && document.querySelectorAll(t).forEach((i) => {
    e ? i.style.overflow = "hidden" : i.style.removeProperty("overflow");
  });
}
function En(e, t) {
  t && document.querySelectorAll(t).forEach((i) => {
    e ? (i.inert = !0, i.setAttribute("aria-hidden", !0)) : (i.inert = null, i.removeAttribute("aria-hidden"));
  });
}
function xn(e, t) {
  En(!!e, t.selectorInert), $n(!!e, t.selectorOverflow);
}
const Ln = {
  autoInit: !1,
  // Data attributes
  dataOpen: "modal-open",
  dataClose: "modal-close",
  dataReplace: "modal-replace",
  dataConfig: "modal-config",
  // Selectors
  selectorModal: ".modal",
  selectorDialog: ".modal__dialog",
  selectorRequired: '[role="alertdialog"]',
  selectorFocus: "[data-focus]",
  selectorInert: null,
  selectorOverflow: "body",
  // State classes
  stateOpened: "is-opened",
  stateOpening: "is-opening",
  stateClosing: "is-closing",
  stateClosed: "is-closed",
  // Feature settings
  customEventPrefix: "modal:",
  eventListeners: !0,
  teleport: null,
  teleportMethod: "append",
  setTabindex: !0,
  transition: !0
};
function ue(e) {
  const t = typeof e == "string" ? this.get(e) : this.get(e.id);
  if (t)
    return t;
  throw new Error(`Modal not found in collection with id of "${e.id || e}".`);
}
function Jt(e) {
  return typeof e == "string" ? e : typeof e.hasAttribute == "function" ? e.hasAttribute(`data-${this.settings.dataOpen}`) ? e.getAttribute(`data-${this.settings.dataOpen}`) : e.hasAttribute(`data-${this.settings.dataClose}`) ? e.getAttribute(`data-${this.settings.dataClose}`) || !1 : e.hasAttribute(`data-${this.settings.dataReplace}`) ? e.getAttribute(`data-${this.settings.dataReplace}`) : e.closest(this.settings.selectorModal) ? (e = e.closest(this.settings.selectorModal), e.id || !1) : !1 : e.id ? e.id : !1;
}
function On(e) {
  const t = Jt.call(this, e);
  if (t) {
    const i = document.querySelector(`#${t}`), n = i ? i.querySelector(this.settings.selectorDialog) : null;
    return !i && !n ? { error: new Error(`No modal elements found using the ID: "${t}".`) } : n ? { modal: i, dialog: n } : { error: new Error("Modal is missing dialog element.") };
  } else
    return { error: new Error("Could not resolve the modal ID.") };
}
function Gt() {
  this.active ? this.focusTrap.mount(this.active.dialog, this.settings.selectorFocus) : (this.trigger && (this.trigger.focus(), this.trigger = null), this.focusTrap.unmount());
}
async function kn(e) {
  let t = e.target.closest(
    `[data-${this.settings.dataOpen}], [data-${this.settings.dataReplace}]`
  );
  if (t) {
    e.preventDefault(), e.target.closest(this.settings.selectorModal) || (this.trigger = t);
    const i = this.get(Jt.call(this, t));
    return t.matches(`[data-${this.settings.dataOpen}]`) ? i.open() : i.replace();
  }
  if (t = e.target.closest(`[data-${this.settings.dataClose}]`), t) {
    e.preventDefault();
    const i = t.getAttribute(`data-${this.settings.dataClose}`);
    return i === "*" ? this.closeAll() : this.close(i);
  }
  if (e.target.matches(this.settings.selectorModal) && !e.target.querySelector(this.settings.selectorRequired))
    return this.close(Jt.call(this, e.target));
}
function Tn(e) {
  if (e.key === "Escape" && this.active && !this.active.dialog.matches(this.settings.selectorRequired))
    return this.close();
}
async function ne(e, t = !0) {
  if (!e)
    return this.collection;
  const i = this.collection.findIndex((n) => n.id === e.id);
  if (i >= 0) {
    const n = this.collection[i];
    t && n.state === "opened" ? await n.close(!1) : this.stack.remove(n), n.getSetting("teleport") && n.teleportReturn(), Object.getOwnPropertyNames(n).forEach((s) => {
      delete n[s];
    }), this.collection.splice(i, 1);
  }
  return this.collection;
}
async function he(e, t, i = !0) {
  const n = ue.call(this, e), s = { ...this.settings, ...n.settings };
  return t !== void 0 && (s.transition = t), this.stack.moveToTop(n), n.state === "closed" && (n.state = "opening", this.stack.add(n), await yn(n.el, s), n.state = "opened"), i && Gt.call(this), n.el.dispatchEvent(new CustomEvent(s.customEventPrefix + "opened", {
    detail: this,
    bubbles: !0
  })), n;
}
async function fe(e, t, i = !0) {
  const n = e ? ue.call(this, e) : this.active;
  if (n && n.state === "opened") {
    n.state = "closing";
    const s = { ...this.settings, ...n.settings };
    t !== void 0 && (s.transition = t), document.activeElement.blur(), await wn(n.el, s), this.stack.remove(n), i && Gt.call(this), n.state = "closed", n.el.dispatchEvent(new CustomEvent(s.customEventPrefix + "closed", {
      detail: this,
      bubbles: !0
    }));
  }
  return n;
}
async function se(e, t) {
  const i = [];
  return await Promise.all(this.stack.value.map(async (n) => {
    e && e === n.id ? Promise.resolve() : i.push(await fe.call(this, n, t, !1)), n.trigger = null;
  })), i;
}
async function ii(e, t, i = !0) {
  const n = ue.call(this, e);
  let s, r;
  return n.state === "opened" ? (s = n, r = await se.call(this, n.id, t)) : (s = he.call(this, n, t, !1), r = se.call(this, !1, t), await Promise.all([s, r])), i && Gt.call(this), { opened: s, closed: r };
}
async function An(e, t) {
  await ne.call(this, e, !1);
  const i = this, n = {
    open(r, a) {
      return he.call(i, this, r, a);
    },
    close(r, a) {
      return fe.call(i, this, r, a);
    },
    replace(r, a) {
      return ii.call(i, this, r, a);
    },
    deregister() {
      return ne.call(i, this);
    },
    teleport(r = this.getSetting("teleport"), a = this.getSetting("teleportMethod")) {
      return this.returnRef ? (console.error("Element has already been teleported:", this.el), !1) : (this.returnRef = We(this.el, r, a), this.el);
    },
    teleportReturn() {
      return this.returnRef ? (this.returnRef = We(this.el, this.returnRef), this.el) : (console.error("No return reference found:", this.el), !1);
    },
    getSetting(r) {
      return r in this.settings ? this.settings[r] : i.settings[r];
    }
  }, s = {
    id: e.id,
    state: "closed",
    el: e,
    dialog: t,
    returnRef: null,
    settings: bn(e, this.settings.dataConfig),
    ...n
  };
  return s.dialog.setAttribute("aria-modal", "true"), s.dialog.hasAttribute("role") || s.dialog.setAttribute("role", "dialog"), s.getSetting("setTabindex") && s.dialog.setAttribute("tabindex", "-1"), s.getSetting("teleport") && s.teleport(), this.collection.push(s), s.el.classList.contains(this.settings.stateOpened) ? await s.open(!1) : (s.el.classList.remove(this.settings.stateOpening), s.el.classList.remove(this.settings.stateClosing), s.el.classList.add(this.settings.stateClosed)), s;
}
function Cn(e) {
  const t = [];
  return {
    get value() {
      return [...t];
    },
    get top() {
      return t[t.length - 1];
    },
    updateIndex() {
      t.forEach((i, n) => {
        i.el.style.zIndex = null;
        const s = getComputedStyle(i.el)["z-index"];
        i.el.style.zIndex = parseInt(s) + n + 1;
      });
    },
    updateGlobalState() {
      xn(this.top, e), this.updateIndex();
    },
    add(i) {
      i.el.style.zIndex = null;
      const n = getComputedStyle(i.el)["z-index"];
      i.el.style.zIndex = parseInt(n) + t.length + 1, t.push(i), this.updateGlobalState();
    },
    remove(i) {
      const n = t.findIndex((s) => s.id === i.id);
      n >= 0 && (i.el.style.zIndex = null, t.splice(n, 1), this.updateGlobalState());
    },
    moveToTop(i) {
      const n = t.findIndex((s) => s.id === i.id);
      n >= 0 && (t.splice(n, 1), this.add(i));
    }
  };
}
var Ot, kt;
class sr extends fn {
  constructor(t) {
    super(), Pe(this, Ot, void 0), Pe(this, kt, void 0), this.defaults = Ln, this.settings = { ...this.defaults, ...t }, this.trigger = null, this.focusTrap = new gn(), this.stack = Cn(this.settings), Me(this, Ot, kn.bind(this)), Me(this, kt, Tn.bind(this)), this.settings.autoInit && this.init();
  }
  get active() {
    return this.stack.top;
  }
  async init(t) {
    t && (this.settings = { ...this.settings, ...t });
    const i = document.querySelectorAll(this.settings.selectorModal);
    return await this.registerCollection(i), this.settings.eventListeners && this.initEventListeners(), this;
  }
  async destroy() {
    return this.trigger = null, await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(), this;
  }
  initEventListeners() {
    document.addEventListener("click", Ft(this, Ot), !1), document.addEventListener("keydown", Ft(this, kt), !1);
  }
  destroyEventListeners() {
    document.removeEventListener("click", Ft(this, Ot), !1), document.removeEventListener("keydown", Ft(this, kt), !1);
  }
  register(t) {
    const i = On.call(this, t);
    return i.error ? Promise.reject(i.error) : An.call(this, i.modal, i.dialog);
  }
  deregister(t) {
    const i = this.get(Jt.call(this, t));
    return ne.call(this, i);
  }
  open(t, i, n) {
    return he.call(this, t, i, n);
  }
  close(t, i, n) {
    return fe.call(this, t, i, n);
  }
  replace(t, i, n) {
    return ii.call(this, t, i, n);
  }
  async closeAll(t = !1, i, n = !0) {
    const s = await se.call(this, t, i);
    return n && Gt.call(this), s;
  }
}
Ot = /* @__PURE__ */ new WeakMap(), kt = /* @__PURE__ */ new WeakMap();
var ni = (e, t, i) => {
  if (!t.has(e))
    throw TypeError("Cannot " + i);
}, je = (e, t, i) => (ni(e, t, "read from private field"), i ? i.call(e) : t.get(e)), In = (e, t, i) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, i);
}, Sn = (e, t, i, n) => (ni(e, t, "write to private field"), n ? n.call(e, i) : t.set(e, i), i);
class qn {
  constructor() {
    this.collection = [];
  }
  async register(t) {
    return await this.deregister(t), this.collection.push(t), this.collection;
  }
  async deregister(t) {
    const i = this.collection.findIndex((n) => n === t);
    if (i >= 0) {
      const n = this.collection[i];
      Object.getOwnPropertyNames(n).forEach((s) => {
        delete n[s];
      }), this.collection.splice(i, 1);
    }
    return this.collection;
  }
  async registerCollection(t) {
    return await Promise.all(Array.from(t, (i) => {
      this.register(i);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(t, i = "id") {
    return this.collection.find((n) => n[i] === t);
  }
}
function Dn() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-variable-prefix").trim();
}
const Pn = {
  autoInit: !1,
  // Selectors
  selectorPopover: ".popover",
  selectorArrow: ".popover__arrow",
  // State classes
  stateActive: "is-active",
  // Feature settings
  eventListeners: !0,
  eventType: "click",
  placement: "bottom"
};
function si(e, t) {
  const i = getComputedStyle(e), n = {
    placement: t.placement,
    event: t.eventType,
    offset: 0,
    "overflow-padding": 0,
    "flip-padding": 0,
    "arrow-element": t.selectorArrow,
    "arrow-padding": 0
  };
  for (const s in n) {
    const r = Dn(), a = i.getPropertyValue(`--${r}popover-${s}`).trim();
    a && (n[s] = a);
  }
  return n;
}
function ee(e) {
  let t;
  const i = typeof e == "string" ? e.trim().split(" ") : [e];
  switch (i.forEach(function(n, s) {
    i[s] = parseInt(n, 10);
  }), i.length) {
    case 1:
      t = i[0];
      break;
    case 2:
      t = {
        top: i[0],
        right: i[1],
        bottom: i[0],
        left: i[1]
      };
      break;
    case 3:
      t = {
        top: i[0],
        right: i[1],
        bottom: i[2],
        left: i[1]
      };
      break;
    case 4:
      t = {
        top: i[0],
        right: i[1],
        bottom: i[2],
        left: i[3]
      };
      break;
    default:
      t = !1;
      break;
  }
  return t;
}
function Mn(e) {
  return [{
    name: "offset",
    options: {
      offset: [0, parseInt(e.offset, 10)]
    }
  }, {
    name: "preventOverflow",
    options: {
      padding: ee(e["overflow-padding"])
    }
  }, {
    name: "flip",
    options: {
      padding: ee(e["flip-padding"])
    }
  }, {
    name: "arrow",
    options: {
      element: e["arrow-element"],
      padding: ee(e["arrow-padding"])
    }
  }];
}
function ri(e) {
  const t = typeof e == "string" ? this.get(e) : this.get(e.id);
  if (t)
    return t;
  throw new Error(`Popover not found in collection with id of "${e}".`);
}
function oi(e) {
  return typeof e == "string" ? e : typeof e.hasAttribute == "function" ? e.closest(this.settings.selectorPopover) ? (e = e.closest(this.settings.selectorPopover), e.id) : e.hasAttribute("aria-controls") ? e.getAttribute("aria-controls") : e.hasAttribute("aria-describedby") ? e.getAttribute("aria-describedby") : !1 : e.id ? e.id : !1;
}
function Wn(e) {
  const t = oi.call(this, e);
  if (t) {
    const i = document.querySelector(`#${t}`), n = document.querySelector(`[aria-controls="${t}"]`) || document.querySelector(`[aria-describedby="${t}"]`);
    return !n && !i ? { error: new Error(`No popover elements found using the ID: "${t}".`) } : n ? i ? { popover: i, trigger: n } : { error: new Error("No popover associated with the provided popover trigger.") } : { error: new Error("No popover trigger associated with the provided popover.") };
  } else
    return { error: new Error("Could not resolve the popover ID.") };
}
async function pe(e) {
  const t = e ? ri.call(this, e) : await ai.call(this);
  return t && t.state === "opened" && (t.el.classList.remove(this.settings.stateActive), t.trigger.hasAttribute("aria-controls") && t.trigger.setAttribute("aria-expanded", "false"), t.popper.setOptions({
    modifiers: [{ name: "eventListeners", enabled: !1 }]
  }), t.state = "closed", t.trigger === this.trigger && (this.trigger = null)), t;
}
async function ai() {
  const e = [];
  return await Promise.all(this.collection.map(async (t) => {
    t.state === "opened" && e.push(await pe.call(this, t));
  })), e;
}
function li(e) {
  e.state == "opened" && setTimeout(() => {
    const t = e.el.closest(":hover") === e.el || e.trigger.closest(":hover") === e.trigger, i = document.activeElement.closest(
      `#${e.id}, [aria-controls="${e.id}"], [aria-describedby="${e.id}"]`
    );
    return !t && !i && e.close(), e;
  }, 1);
}
function jn(e) {
  e.state === "opened" ? e.close() : (this.trigger = e.trigger, e.open(), ci.call(this, e));
}
function Nn(e) {
  switch (e.key) {
    case "Escape":
      this.trigger && this.trigger.focus(), ai.call(this);
      return;
    case "Tab":
      this.collection.forEach((t) => {
        li.call(this, t);
      });
      return;
    default:
      return;
  }
}
function ci(e) {
  const t = this;
  document.addEventListener("click", function i(n) {
    n.target.closest(
      `#${e.id}, [aria-controls="${e.id}"], [aria-describedby="${e.id}"]`
    ) ? e.el && !e.el.classList.contains(t.settings.stateActive) && this.removeEventListener("click", i) : (e.el && e.el.classList.contains(t.settings.stateActive) && e.close(), this.removeEventListener("click", i));
  });
}
var W = "top", B = "bottom", R = "right", j = "left", ge = "auto", qt = [W, B, R, j], ft = "start", It = "end", _n = "clippingParents", di = "viewport", yt = "popper", Fn = "reference", Ne = /* @__PURE__ */ qt.reduce(function(e, t) {
  return e.concat([t + "-" + ft, t + "-" + It]);
}, []), ui = /* @__PURE__ */ [].concat(qt, [ge]).reduce(function(e, t) {
  return e.concat([t, t + "-" + ft, t + "-" + It]);
}, []), Bn = "beforeRead", Rn = "read", Hn = "afterRead", Vn = "beforeMain", Jn = "main", zn = "afterMain", Kn = "beforeWrite", Gn = "write", Qn = "afterWrite", Zn = [Bn, Rn, Hn, Vn, Jn, zn, Kn, Gn, Qn];
function z(e) {
  return e ? (e.nodeName || "").toLowerCase() : null;
}
function _(e) {
  if (e == null)
    return window;
  if (e.toString() !== "[object Window]") {
    var t = e.ownerDocument;
    return t && t.defaultView || window;
  }
  return e;
}
function rt(e) {
  var t = _(e).Element;
  return e instanceof t || e instanceof Element;
}
function F(e) {
  var t = _(e).HTMLElement;
  return e instanceof t || e instanceof HTMLElement;
}
function me(e) {
  if (typeof ShadowRoot > "u")
    return !1;
  var t = _(e).ShadowRoot;
  return e instanceof t || e instanceof ShadowRoot;
}
function Un(e) {
  var t = e.state;
  Object.keys(t.elements).forEach(function(i) {
    var n = t.styles[i] || {}, s = t.attributes[i] || {}, r = t.elements[i];
    !F(r) || !z(r) || (Object.assign(r.style, n), Object.keys(s).forEach(function(a) {
      var l = s[a];
      l === !1 ? r.removeAttribute(a) : r.setAttribute(a, l === !0 ? "" : l);
    }));
  });
}
function Xn(e) {
  var t = e.state, i = {
    popper: {
      position: t.options.strategy,
      left: "0",
      top: "0",
      margin: "0"
    },
    arrow: {
      position: "absolute"
    },
    reference: {}
  };
  return Object.assign(t.elements.popper.style, i.popper), t.styles = i, t.elements.arrow && Object.assign(t.elements.arrow.style, i.arrow), function() {
    Object.keys(t.elements).forEach(function(n) {
      var s = t.elements[n], r = t.attributes[n] || {}, a = Object.keys(t.styles.hasOwnProperty(n) ? t.styles[n] : i[n]), l = a.reduce(function(o, c) {
        return o[c] = "", o;
      }, {});
      !F(s) || !z(s) || (Object.assign(s.style, l), Object.keys(r).forEach(function(o) {
        s.removeAttribute(o);
      }));
    });
  };
}
const Yn = {
  name: "applyStyles",
  enabled: !0,
  phase: "write",
  fn: Un,
  effect: Xn,
  requires: ["computeStyles"]
};
function J(e) {
  return e.split("-")[0];
}
var st = Math.max, zt = Math.min, pt = Math.round;
function re() {
  var e = navigator.userAgentData;
  return e != null && e.brands && Array.isArray(e.brands) ? e.brands.map(function(t) {
    return t.brand + "/" + t.version;
  }).join(" ") : navigator.userAgent;
}
function hi() {
  return !/^((?!chrome|android).)*safari/i.test(re());
}
function gt(e, t, i) {
  t === void 0 && (t = !1), i === void 0 && (i = !1);
  var n = e.getBoundingClientRect(), s = 1, r = 1;
  t && F(e) && (s = e.offsetWidth > 0 && pt(n.width) / e.offsetWidth || 1, r = e.offsetHeight > 0 && pt(n.height) / e.offsetHeight || 1);
  var a = rt(e) ? _(e) : window, l = a.visualViewport, o = !hi() && i, c = (n.left + (o && l ? l.offsetLeft : 0)) / s, d = (n.top + (o && l ? l.offsetTop : 0)) / r, b = n.width / s, v = n.height / r;
  return {
    width: b,
    height: v,
    top: d,
    right: c + b,
    bottom: d + v,
    left: c,
    x: c,
    y: d
  };
}
function ve(e) {
  var t = gt(e), i = e.offsetWidth, n = e.offsetHeight;
  return Math.abs(t.width - i) <= 1 && (i = t.width), Math.abs(t.height - n) <= 1 && (n = t.height), {
    x: e.offsetLeft,
    y: e.offsetTop,
    width: i,
    height: n
  };
}
function fi(e, t) {
  var i = t.getRootNode && t.getRootNode();
  if (e.contains(t))
    return !0;
  if (i && me(i)) {
    var n = t;
    do {
      if (n && e.isSameNode(n))
        return !0;
      n = n.parentNode || n.host;
    } while (n);
  }
  return !1;
}
function G(e) {
  return _(e).getComputedStyle(e);
}
function ts(e) {
  return ["table", "td", "th"].indexOf(z(e)) >= 0;
}
function Z(e) {
  return ((rt(e) ? e.ownerDocument : (
    // $FlowFixMe[prop-missing]
    e.document
  )) || window.document).documentElement;
}
function Qt(e) {
  return z(e) === "html" ? e : (
    // this is a quicker (but less type safe) way to save quite some bytes from the bundle
    // $FlowFixMe[incompatible-return]
    // $FlowFixMe[prop-missing]
    e.assignedSlot || // step into the shadow DOM of the parent of a slotted node
    e.parentNode || // DOM Element detected
    (me(e) ? e.host : null) || // ShadowRoot detected
    // $FlowFixMe[incompatible-call]: HTMLElement is a Node
    Z(e)
  );
}
function _e(e) {
  return !F(e) || // https://github.com/popperjs/popper-core/issues/837
  G(e).position === "fixed" ? null : e.offsetParent;
}
function es(e) {
  var t = /firefox/i.test(re()), i = /Trident/i.test(re());
  if (i && F(e)) {
    var n = G(e);
    if (n.position === "fixed")
      return null;
  }
  var s = Qt(e);
  for (me(s) && (s = s.host); F(s) && ["html", "body"].indexOf(z(s)) < 0; ) {
    var r = G(s);
    if (r.transform !== "none" || r.perspective !== "none" || r.contain === "paint" || ["transform", "perspective"].indexOf(r.willChange) !== -1 || t && r.willChange === "filter" || t && r.filter && r.filter !== "none")
      return s;
    s = s.parentNode;
  }
  return null;
}
function Dt(e) {
  for (var t = _(e), i = _e(e); i && ts(i) && G(i).position === "static"; )
    i = _e(i);
  return i && (z(i) === "html" || z(i) === "body" && G(i).position === "static") ? t : i || es(e) || t;
}
function be(e) {
  return ["top", "bottom"].indexOf(e) >= 0 ? "x" : "y";
}
function At(e, t, i) {
  return st(e, zt(t, i));
}
function is(e, t, i) {
  var n = At(e, t, i);
  return n > i ? i : n;
}
function pi() {
  return {
    top: 0,
    right: 0,
    bottom: 0,
    left: 0
  };
}
function gi(e) {
  return Object.assign({}, pi(), e);
}
function mi(e, t) {
  return t.reduce(function(i, n) {
    return i[n] = e, i;
  }, {});
}
var ns = function(e, t) {
  return e = typeof e == "function" ? e(Object.assign({}, t.rects, {
    placement: t.placement
  })) : e, gi(typeof e != "number" ? e : mi(e, qt));
};
function ss(e) {
  var t, i = e.state, n = e.name, s = e.options, r = i.elements.arrow, a = i.modifiersData.popperOffsets, l = J(i.placement), o = be(l), c = [j, R].indexOf(l) >= 0, d = c ? "height" : "width";
  if (!(!r || !a)) {
    var b = ns(s.padding, i), v = ve(r), h = o === "y" ? W : j, $ = o === "y" ? B : R, u = i.rects.reference[d] + i.rects.reference[o] - a[o] - i.rects.popper[d], w = a[o] - i.rects.reference[o], E = Dt(r), L = E ? o === "y" ? E.clientHeight || 0 : E.clientWidth || 0 : 0, O = u / 2 - w / 2, f = b[h], y = L - v[d] - b[$], x = L / 2 - v[d] / 2 + O, k = At(f, x, y), T = o;
    i.modifiersData[n] = (t = {}, t[T] = k, t.centerOffset = k - x, t);
  }
}
function rs(e) {
  var t = e.state, i = e.options, n = i.element, s = n === void 0 ? "[data-popper-arrow]" : n;
  s != null && (typeof s == "string" && (s = t.elements.popper.querySelector(s), !s) || fi(t.elements.popper, s) && (t.elements.arrow = s));
}
const os = {
  name: "arrow",
  enabled: !0,
  phase: "main",
  fn: ss,
  effect: rs,
  requires: ["popperOffsets"],
  requiresIfExists: ["preventOverflow"]
};
function mt(e) {
  return e.split("-")[1];
}
var as = {
  top: "auto",
  right: "auto",
  bottom: "auto",
  left: "auto"
};
function ls(e, t) {
  var i = e.x, n = e.y, s = t.devicePixelRatio || 1;
  return {
    x: pt(i * s) / s || 0,
    y: pt(n * s) / s || 0
  };
}
function Fe(e) {
  var t, i = e.popper, n = e.popperRect, s = e.placement, r = e.variation, a = e.offsets, l = e.position, o = e.gpuAcceleration, c = e.adaptive, d = e.roundOffsets, b = e.isFixed, v = a.x, h = v === void 0 ? 0 : v, $ = a.y, u = $ === void 0 ? 0 : $, w = typeof d == "function" ? d({
    x: h,
    y: u
  }) : {
    x: h,
    y: u
  };
  h = w.x, u = w.y;
  var E = a.hasOwnProperty("x"), L = a.hasOwnProperty("y"), O = j, f = W, y = window;
  if (c) {
    var x = Dt(i), k = "clientHeight", T = "clientWidth";
    if (x === _(i) && (x = Z(i), G(x).position !== "static" && l === "absolute" && (k = "scrollHeight", T = "scrollWidth")), x = x, s === W || (s === j || s === R) && r === It) {
      f = B;
      var A = b && x === y && y.visualViewport ? y.visualViewport.height : (
        // $FlowFixMe[prop-missing]
        x[k]
      );
      u -= A - n.height, u *= o ? 1 : -1;
    }
    if (s === j || (s === W || s === B) && r === It) {
      O = R;
      var C = b && x === y && y.visualViewport ? y.visualViewport.width : (
        // $FlowFixMe[prop-missing]
        x[T]
      );
      h -= C - n.width, h *= o ? 1 : -1;
    }
  }
  var I = Object.assign({
    position: l
  }, c && as), H = d === !0 ? ls({
    x: h,
    y: u
  }, _(i)) : {
    x: h,
    y: u
  };
  if (h = H.x, u = H.y, o) {
    var D;
    return Object.assign({}, I, (D = {}, D[f] = L ? "0" : "", D[O] = E ? "0" : "", D.transform = (y.devicePixelRatio || 1) <= 1 ? "translate(" + h + "px, " + u + "px)" : "translate3d(" + h + "px, " + u + "px, 0)", D));
  }
  return Object.assign({}, I, (t = {}, t[f] = L ? u + "px" : "", t[O] = E ? h + "px" : "", t.transform = "", t));
}
function cs(e) {
  var t = e.state, i = e.options, n = i.gpuAcceleration, s = n === void 0 ? !0 : n, r = i.adaptive, a = r === void 0 ? !0 : r, l = i.roundOffsets, o = l === void 0 ? !0 : l, c = {
    placement: J(t.placement),
    variation: mt(t.placement),
    popper: t.elements.popper,
    popperRect: t.rects.popper,
    gpuAcceleration: s,
    isFixed: t.options.strategy === "fixed"
  };
  t.modifiersData.popperOffsets != null && (t.styles.popper = Object.assign({}, t.styles.popper, Fe(Object.assign({}, c, {
    offsets: t.modifiersData.popperOffsets,
    position: t.options.strategy,
    adaptive: a,
    roundOffsets: o
  })))), t.modifiersData.arrow != null && (t.styles.arrow = Object.assign({}, t.styles.arrow, Fe(Object.assign({}, c, {
    offsets: t.modifiersData.arrow,
    position: "absolute",
    adaptive: !1,
    roundOffsets: o
  })))), t.attributes.popper = Object.assign({}, t.attributes.popper, {
    "data-popper-placement": t.placement
  });
}
const ds = {
  name: "computeStyles",
  enabled: !0,
  phase: "beforeWrite",
  fn: cs,
  data: {}
};
var Bt = {
  passive: !0
};
function us(e) {
  var t = e.state, i = e.instance, n = e.options, s = n.scroll, r = s === void 0 ? !0 : s, a = n.resize, l = a === void 0 ? !0 : a, o = _(t.elements.popper), c = [].concat(t.scrollParents.reference, t.scrollParents.popper);
  return r && c.forEach(function(d) {
    d.addEventListener("scroll", i.update, Bt);
  }), l && o.addEventListener("resize", i.update, Bt), function() {
    r && c.forEach(function(d) {
      d.removeEventListener("scroll", i.update, Bt);
    }), l && o.removeEventListener("resize", i.update, Bt);
  };
}
const hs = {
  name: "eventListeners",
  enabled: !0,
  phase: "write",
  fn: function() {
  },
  effect: us,
  data: {}
};
var fs = {
  left: "right",
  right: "left",
  bottom: "top",
  top: "bottom"
};
function Vt(e) {
  return e.replace(/left|right|bottom|top/g, function(t) {
    return fs[t];
  });
}
var ps = {
  start: "end",
  end: "start"
};
function Be(e) {
  return e.replace(/start|end/g, function(t) {
    return ps[t];
  });
}
function ye(e) {
  var t = _(e), i = t.pageXOffset, n = t.pageYOffset;
  return {
    scrollLeft: i,
    scrollTop: n
  };
}
function we(e) {
  return gt(Z(e)).left + ye(e).scrollLeft;
}
function gs(e, t) {
  var i = _(e), n = Z(e), s = i.visualViewport, r = n.clientWidth, a = n.clientHeight, l = 0, o = 0;
  if (s) {
    r = s.width, a = s.height;
    var c = hi();
    (c || !c && t === "fixed") && (l = s.offsetLeft, o = s.offsetTop);
  }
  return {
    width: r,
    height: a,
    x: l + we(e),
    y: o
  };
}
function ms(e) {
  var t, i = Z(e), n = ye(e), s = (t = e.ownerDocument) == null ? void 0 : t.body, r = st(i.scrollWidth, i.clientWidth, s ? s.scrollWidth : 0, s ? s.clientWidth : 0), a = st(i.scrollHeight, i.clientHeight, s ? s.scrollHeight : 0, s ? s.clientHeight : 0), l = -n.scrollLeft + we(e), o = -n.scrollTop;
  return G(s || i).direction === "rtl" && (l += st(i.clientWidth, s ? s.clientWidth : 0) - r), {
    width: r,
    height: a,
    x: l,
    y: o
  };
}
function $e(e) {
  var t = G(e), i = t.overflow, n = t.overflowX, s = t.overflowY;
  return /auto|scroll|overlay|hidden/.test(i + s + n);
}
function vi(e) {
  return ["html", "body", "#document"].indexOf(z(e)) >= 0 ? e.ownerDocument.body : F(e) && $e(e) ? e : vi(Qt(e));
}
function Ct(e, t) {
  var i;
  t === void 0 && (t = []);
  var n = vi(e), s = n === ((i = e.ownerDocument) == null ? void 0 : i.body), r = _(n), a = s ? [r].concat(r.visualViewport || [], $e(n) ? n : []) : n, l = t.concat(a);
  return s ? l : (
    // $FlowFixMe[incompatible-call]: isBody tells us target will be an HTMLElement here
    l.concat(Ct(Qt(a)))
  );
}
function oe(e) {
  return Object.assign({}, e, {
    left: e.x,
    top: e.y,
    right: e.x + e.width,
    bottom: e.y + e.height
  });
}
function vs(e, t) {
  var i = gt(e, !1, t === "fixed");
  return i.top = i.top + e.clientTop, i.left = i.left + e.clientLeft, i.bottom = i.top + e.clientHeight, i.right = i.left + e.clientWidth, i.width = e.clientWidth, i.height = e.clientHeight, i.x = i.left, i.y = i.top, i;
}
function Re(e, t, i) {
  return t === di ? oe(gs(e, i)) : rt(t) ? vs(t, i) : oe(ms(Z(e)));
}
function bs(e) {
  var t = Ct(Qt(e)), i = ["absolute", "fixed"].indexOf(G(e).position) >= 0, n = i && F(e) ? Dt(e) : e;
  return rt(n) ? t.filter(function(s) {
    return rt(s) && fi(s, n) && z(s) !== "body";
  }) : [];
}
function ys(e, t, i, n) {
  var s = t === "clippingParents" ? bs(e) : [].concat(t), r = [].concat(s, [i]), a = r[0], l = r.reduce(function(o, c) {
    var d = Re(e, c, n);
    return o.top = st(d.top, o.top), o.right = zt(d.right, o.right), o.bottom = zt(d.bottom, o.bottom), o.left = st(d.left, o.left), o;
  }, Re(e, a, n));
  return l.width = l.right - l.left, l.height = l.bottom - l.top, l.x = l.left, l.y = l.top, l;
}
function bi(e) {
  var t = e.reference, i = e.element, n = e.placement, s = n ? J(n) : null, r = n ? mt(n) : null, a = t.x + t.width / 2 - i.width / 2, l = t.y + t.height / 2 - i.height / 2, o;
  switch (s) {
    case W:
      o = {
        x: a,
        y: t.y - i.height
      };
      break;
    case B:
      o = {
        x: a,
        y: t.y + t.height
      };
      break;
    case R:
      o = {
        x: t.x + t.width,
        y: l
      };
      break;
    case j:
      o = {
        x: t.x - i.width,
        y: l
      };
      break;
    default:
      o = {
        x: t.x,
        y: t.y
      };
  }
  var c = s ? be(s) : null;
  if (c != null) {
    var d = c === "y" ? "height" : "width";
    switch (r) {
      case ft:
        o[c] = o[c] - (t[d] / 2 - i[d] / 2);
        break;
      case It:
        o[c] = o[c] + (t[d] / 2 - i[d] / 2);
        break;
    }
  }
  return o;
}
function St(e, t) {
  t === void 0 && (t = {});
  var i = t, n = i.placement, s = n === void 0 ? e.placement : n, r = i.strategy, a = r === void 0 ? e.strategy : r, l = i.boundary, o = l === void 0 ? _n : l, c = i.rootBoundary, d = c === void 0 ? di : c, b = i.elementContext, v = b === void 0 ? yt : b, h = i.altBoundary, $ = h === void 0 ? !1 : h, u = i.padding, w = u === void 0 ? 0 : u, E = gi(typeof w != "number" ? w : mi(w, qt)), L = v === yt ? Fn : yt, O = e.rects.popper, f = e.elements[$ ? L : v], y = ys(rt(f) ? f : f.contextElement || Z(e.elements.popper), o, d, a), x = gt(e.elements.reference), k = bi({
    reference: x,
    element: O,
    strategy: "absolute",
    placement: s
  }), T = oe(Object.assign({}, O, k)), A = v === yt ? T : x, C = {
    top: y.top - A.top + E.top,
    bottom: A.bottom - y.bottom + E.bottom,
    left: y.left - A.left + E.left,
    right: A.right - y.right + E.right
  }, I = e.modifiersData.offset;
  if (v === yt && I) {
    var H = I[s];
    Object.keys(C).forEach(function(D) {
      var U = [R, B].indexOf(D) >= 0 ? 1 : -1, X = [W, B].indexOf(D) >= 0 ? "y" : "x";
      C[D] += H[X] * U;
    });
  }
  return C;
}
function ws(e, t) {
  t === void 0 && (t = {});
  var i = t, n = i.placement, s = i.boundary, r = i.rootBoundary, a = i.padding, l = i.flipVariations, o = i.allowedAutoPlacements, c = o === void 0 ? ui : o, d = mt(n), b = d ? l ? Ne : Ne.filter(function($) {
    return mt($) === d;
  }) : qt, v = b.filter(function($) {
    return c.indexOf($) >= 0;
  });
  v.length === 0 && (v = b);
  var h = v.reduce(function($, u) {
    return $[u] = St(e, {
      placement: u,
      boundary: s,
      rootBoundary: r,
      padding: a
    })[J(u)], $;
  }, {});
  return Object.keys(h).sort(function($, u) {
    return h[$] - h[u];
  });
}
function $s(e) {
  if (J(e) === ge)
    return [];
  var t = Vt(e);
  return [Be(e), t, Be(t)];
}
function Es(e) {
  var t = e.state, i = e.options, n = e.name;
  if (!t.modifiersData[n]._skip) {
    for (var s = i.mainAxis, r = s === void 0 ? !0 : s, a = i.altAxis, l = a === void 0 ? !0 : a, o = i.fallbackPlacements, c = i.padding, d = i.boundary, b = i.rootBoundary, v = i.altBoundary, h = i.flipVariations, $ = h === void 0 ? !0 : h, u = i.allowedAutoPlacements, w = t.options.placement, E = J(w), L = E === w, O = o || (L || !$ ? [Vt(w)] : $s(w)), f = [w].concat(O).reduce(function(tt, K) {
      return tt.concat(J(K) === ge ? ws(t, {
        placement: K,
        boundary: d,
        rootBoundary: b,
        padding: c,
        flipVariations: $,
        allowedAutoPlacements: u
      }) : K);
    }, []), y = t.rects.reference, x = t.rects.popper, k = /* @__PURE__ */ new Map(), T = !0, A = f[0], C = 0; C < f.length; C++) {
      var I = f[C], H = J(I), D = mt(I) === ft, U = [W, B].indexOf(H) >= 0, X = U ? "width" : "height", N = St(t, {
        placement: I,
        boundary: d,
        rootBoundary: b,
        altBoundary: v,
        padding: c
      }), V = U ? D ? R : j : D ? B : W;
      y[X] > x[X] && (V = Vt(V));
      var Pt = Vt(V), Y = [];
      if (r && Y.push(N[H] <= 0), l && Y.push(N[V] <= 0, N[Pt] <= 0), Y.every(function(tt) {
        return tt;
      })) {
        A = I, T = !1;
        break;
      }
      k.set(I, Y);
    }
    if (T)
      for (var Mt = $ ? 3 : 1, Zt = function(tt) {
        var K = f.find(function(jt) {
          var bt = k.get(jt);
          if (bt)
            return bt.slice(0, tt).every(function(ot) {
              return ot;
            });
        });
        if (K)
          return A = K, "break";
      }, vt = Mt; vt > 0; vt--) {
        var Wt = Zt(vt);
        if (Wt === "break")
          break;
      }
    t.placement !== A && (t.modifiersData[n]._skip = !0, t.placement = A, t.reset = !0);
  }
}
const xs = {
  name: "flip",
  enabled: !0,
  phase: "main",
  fn: Es,
  requiresIfExists: ["offset"],
  data: {
    _skip: !1
  }
};
function He(e, t, i) {
  return i === void 0 && (i = {
    x: 0,
    y: 0
  }), {
    top: e.top - t.height - i.y,
    right: e.right - t.width + i.x,
    bottom: e.bottom - t.height + i.y,
    left: e.left - t.width - i.x
  };
}
function Ve(e) {
  return [W, R, B, j].some(function(t) {
    return e[t] >= 0;
  });
}
function Ls(e) {
  var t = e.state, i = e.name, n = t.rects.reference, s = t.rects.popper, r = t.modifiersData.preventOverflow, a = St(t, {
    elementContext: "reference"
  }), l = St(t, {
    altBoundary: !0
  }), o = He(a, n), c = He(l, s, r), d = Ve(o), b = Ve(c);
  t.modifiersData[i] = {
    referenceClippingOffsets: o,
    popperEscapeOffsets: c,
    isReferenceHidden: d,
    hasPopperEscaped: b
  }, t.attributes.popper = Object.assign({}, t.attributes.popper, {
    "data-popper-reference-hidden": d,
    "data-popper-escaped": b
  });
}
const Os = {
  name: "hide",
  enabled: !0,
  phase: "main",
  requiresIfExists: ["preventOverflow"],
  fn: Ls
};
function ks(e, t, i) {
  var n = J(e), s = [j, W].indexOf(n) >= 0 ? -1 : 1, r = typeof i == "function" ? i(Object.assign({}, t, {
    placement: e
  })) : i, a = r[0], l = r[1];
  return a = a || 0, l = (l || 0) * s, [j, R].indexOf(n) >= 0 ? {
    x: l,
    y: a
  } : {
    x: a,
    y: l
  };
}
function Ts(e) {
  var t = e.state, i = e.options, n = e.name, s = i.offset, r = s === void 0 ? [0, 0] : s, a = ui.reduce(function(d, b) {
    return d[b] = ks(b, t.rects, r), d;
  }, {}), l = a[t.placement], o = l.x, c = l.y;
  t.modifiersData.popperOffsets != null && (t.modifiersData.popperOffsets.x += o, t.modifiersData.popperOffsets.y += c), t.modifiersData[n] = a;
}
const As = {
  name: "offset",
  enabled: !0,
  phase: "main",
  requires: ["popperOffsets"],
  fn: Ts
};
function Cs(e) {
  var t = e.state, i = e.name;
  t.modifiersData[i] = bi({
    reference: t.rects.reference,
    element: t.rects.popper,
    strategy: "absolute",
    placement: t.placement
  });
}
const Is = {
  name: "popperOffsets",
  enabled: !0,
  phase: "read",
  fn: Cs,
  data: {}
};
function Ss(e) {
  return e === "x" ? "y" : "x";
}
function qs(e) {
  var t = e.state, i = e.options, n = e.name, s = i.mainAxis, r = s === void 0 ? !0 : s, a = i.altAxis, l = a === void 0 ? !1 : a, o = i.boundary, c = i.rootBoundary, d = i.altBoundary, b = i.padding, v = i.tether, h = v === void 0 ? !0 : v, $ = i.tetherOffset, u = $ === void 0 ? 0 : $, w = St(t, {
    boundary: o,
    rootBoundary: c,
    padding: b,
    altBoundary: d
  }), E = J(t.placement), L = mt(t.placement), O = !L, f = be(E), y = Ss(f), x = t.modifiersData.popperOffsets, k = t.rects.reference, T = t.rects.popper, A = typeof u == "function" ? u(Object.assign({}, t.rects, {
    placement: t.placement
  })) : u, C = typeof A == "number" ? {
    mainAxis: A,
    altAxis: A
  } : Object.assign({
    mainAxis: 0,
    altAxis: 0
  }, A), I = t.modifiersData.offset ? t.modifiersData.offset[t.placement] : null, H = {
    x: 0,
    y: 0
  };
  if (x) {
    if (r) {
      var D, U = f === "y" ? W : j, X = f === "y" ? B : R, N = f === "y" ? "height" : "width", V = x[f], Pt = V + w[U], Y = V - w[X], Mt = h ? -T[N] / 2 : 0, Zt = L === ft ? k[N] : T[N], vt = L === ft ? -T[N] : -k[N], Wt = t.elements.arrow, tt = h && Wt ? ve(Wt) : {
        width: 0,
        height: 0
      }, K = t.modifiersData["arrow#persistent"] ? t.modifiersData["arrow#persistent"].padding : pi(), jt = K[U], bt = K[X], ot = At(0, k[N], tt[N]), $i = O ? k[N] / 2 - Mt - ot - jt - C.mainAxis : Zt - ot - jt - C.mainAxis, Ei = O ? -k[N] / 2 + Mt + ot + bt + C.mainAxis : vt + ot + bt + C.mainAxis, Ut = t.elements.arrow && Dt(t.elements.arrow), xi = Ut ? f === "y" ? Ut.clientTop || 0 : Ut.clientLeft || 0 : 0, xe = (D = I == null ? void 0 : I[f]) != null ? D : 0, Li = V + $i - xe - xi, Oi = V + Ei - xe, Le = At(h ? zt(Pt, Li) : Pt, V, h ? st(Y, Oi) : Y);
      x[f] = Le, H[f] = Le - V;
    }
    if (l) {
      var Oe, ki = f === "x" ? W : j, Ti = f === "x" ? B : R, et = x[y], Nt = y === "y" ? "height" : "width", ke = et + w[ki], Te = et - w[Ti], Xt = [W, j].indexOf(E) !== -1, Ae = (Oe = I == null ? void 0 : I[y]) != null ? Oe : 0, Ce = Xt ? ke : et - k[Nt] - T[Nt] - Ae + C.altAxis, Ie = Xt ? et + k[Nt] + T[Nt] - Ae - C.altAxis : Te, Se = h && Xt ? is(Ce, et, Ie) : At(h ? Ce : ke, et, h ? Ie : Te);
      x[y] = Se, H[y] = Se - et;
    }
    t.modifiersData[n] = H;
  }
}
const Ds = {
  name: "preventOverflow",
  enabled: !0,
  phase: "main",
  fn: qs,
  requiresIfExists: ["offset"]
};
function Ps(e) {
  return {
    scrollLeft: e.scrollLeft,
    scrollTop: e.scrollTop
  };
}
function Ms(e) {
  return e === _(e) || !F(e) ? ye(e) : Ps(e);
}
function Ws(e) {
  var t = e.getBoundingClientRect(), i = pt(t.width) / e.offsetWidth || 1, n = pt(t.height) / e.offsetHeight || 1;
  return i !== 1 || n !== 1;
}
function js(e, t, i) {
  i === void 0 && (i = !1);
  var n = F(t), s = F(t) && Ws(t), r = Z(t), a = gt(e, s, i), l = {
    scrollLeft: 0,
    scrollTop: 0
  }, o = {
    x: 0,
    y: 0
  };
  return (n || !n && !i) && ((z(t) !== "body" || // https://github.com/popperjs/popper-core/issues/1078
  $e(r)) && (l = Ms(t)), F(t) ? (o = gt(t, !0), o.x += t.clientLeft, o.y += t.clientTop) : r && (o.x = we(r))), {
    x: a.left + l.scrollLeft - o.x,
    y: a.top + l.scrollTop - o.y,
    width: a.width,
    height: a.height
  };
}
function Ns(e) {
  var t = /* @__PURE__ */ new Map(), i = /* @__PURE__ */ new Set(), n = [];
  e.forEach(function(r) {
    t.set(r.name, r);
  });
  function s(r) {
    i.add(r.name);
    var a = [].concat(r.requires || [], r.requiresIfExists || []);
    a.forEach(function(l) {
      if (!i.has(l)) {
        var o = t.get(l);
        o && s(o);
      }
    }), n.push(r);
  }
  return e.forEach(function(r) {
    i.has(r.name) || s(r);
  }), n;
}
function _s(e) {
  var t = Ns(e);
  return Zn.reduce(function(i, n) {
    return i.concat(t.filter(function(s) {
      return s.phase === n;
    }));
  }, []);
}
function Fs(e) {
  var t;
  return function() {
    return t || (t = new Promise(function(i) {
      Promise.resolve().then(function() {
        t = void 0, i(e());
      });
    })), t;
  };
}
function Bs(e) {
  var t = e.reduce(function(i, n) {
    var s = i[n.name];
    return i[n.name] = s ? Object.assign({}, s, n, {
      options: Object.assign({}, s.options, n.options),
      data: Object.assign({}, s.data, n.data)
    }) : n, i;
  }, {});
  return Object.keys(t).map(function(i) {
    return t[i];
  });
}
var Je = {
  placement: "bottom",
  modifiers: [],
  strategy: "absolute"
};
function ze() {
  for (var e = arguments.length, t = new Array(e), i = 0; i < e; i++)
    t[i] = arguments[i];
  return !t.some(function(n) {
    return !(n && typeof n.getBoundingClientRect == "function");
  });
}
function Rs(e) {
  e === void 0 && (e = {});
  var t = e, i = t.defaultModifiers, n = i === void 0 ? [] : i, s = t.defaultOptions, r = s === void 0 ? Je : s;
  return function(a, l, o) {
    o === void 0 && (o = r);
    var c = {
      placement: "bottom",
      orderedModifiers: [],
      options: Object.assign({}, Je, r),
      modifiersData: {},
      elements: {
        reference: a,
        popper: l
      },
      attributes: {},
      styles: {}
    }, d = [], b = !1, v = {
      state: c,
      setOptions: function(u) {
        var w = typeof u == "function" ? u(c.options) : u;
        $(), c.options = Object.assign({}, r, c.options, w), c.scrollParents = {
          reference: rt(a) ? Ct(a) : a.contextElement ? Ct(a.contextElement) : [],
          popper: Ct(l)
        };
        var E = _s(Bs([].concat(n, c.options.modifiers)));
        return c.orderedModifiers = E.filter(function(L) {
          return L.enabled;
        }), h(), v.update();
      },
      // Sync update – it will always be executed, even if not necessary. This
      // is useful for low frequency updates where sync behavior simplifies the
      // logic.
      // For high frequency updates (e.g. `resize` and `scroll` events), always
      // prefer the async Popper#update method
      forceUpdate: function() {
        if (!b) {
          var u = c.elements, w = u.reference, E = u.popper;
          if (ze(w, E)) {
            c.rects = {
              reference: js(w, Dt(E), c.options.strategy === "fixed"),
              popper: ve(E)
            }, c.reset = !1, c.placement = c.options.placement, c.orderedModifiers.forEach(function(T) {
              return c.modifiersData[T.name] = Object.assign({}, T.data);
            });
            for (var L = 0; L < c.orderedModifiers.length; L++) {
              if (c.reset === !0) {
                c.reset = !1, L = -1;
                continue;
              }
              var O = c.orderedModifiers[L], f = O.fn, y = O.options, x = y === void 0 ? {} : y, k = O.name;
              typeof f == "function" && (c = f({
                state: c,
                options: x,
                name: k,
                instance: v
              }) || c);
            }
          }
        }
      },
      // Async and optimistically optimized update – it will not be executed if
      // not necessary (debounced to run at most once-per-tick)
      update: Fs(function() {
        return new Promise(function(u) {
          v.forceUpdate(), u(c);
        });
      }),
      destroy: function() {
        $(), b = !0;
      }
    };
    if (!ze(a, l))
      return v;
    v.setOptions(o).then(function(u) {
      !b && o.onFirstUpdate && o.onFirstUpdate(u);
    });
    function h() {
      c.orderedModifiers.forEach(function(u) {
        var w = u.name, E = u.options, L = E === void 0 ? {} : E, O = u.effect;
        if (typeof O == "function") {
          var f = O({
            state: c,
            name: w,
            instance: v,
            options: L
          }), y = function() {
          };
          d.push(f || y);
        }
      });
    }
    function $() {
      d.forEach(function(u) {
        return u();
      }), d = [];
    }
    return v;
  };
}
var Hs = [hs, Is, ds, Yn, As, xs, Ds, os, Os], Vs = /* @__PURE__ */ Rs({
  defaultModifiers: Hs
});
async function ae(e) {
  if (!e)
    return this.collection;
  const t = this.collection.findIndex((i) => i.id === e.id);
  if (t >= 0) {
    const i = this.collection[t];
    i.state === "opened" && i.close(), i.popper.destroy(), yi(i), Object.getOwnPropertyNames(i).forEach((n) => {
      delete i[n];
    }), this.collection.splice(t, 1);
  }
  return this.collection;
}
function yi(e) {
  return e.__eventListeners && (e.__eventListeners.forEach((t) => {
    t.el.forEach((i) => {
      t.type.forEach((n) => {
        e[i].removeEventListener(n, t.listener, !1);
      });
    });
  }), delete e.__eventListeners), e;
}
async function Ee(e) {
  const t = ri.call(this, e);
  return t.el.classList.add(this.settings.stateActive), t.trigger.hasAttribute("aria-controls") && t.trigger.setAttribute("aria-expanded", "true"), t.config = si(t.el, this.settings), t.popper.setOptions({
    placement: t.config.placement,
    modifiers: [
      { name: "eventListeners", enabled: !0 },
      ...Mn(t.config)
    ]
  }), t.popper.update(), t.state = "opened", t;
}
async function Js(e, t) {
  ae.call(this, e);
  const i = this, n = {
    open() {
      return Ee.call(i, this);
    },
    close() {
      return pe.call(i, this);
    },
    deregister() {
      return ae.call(i, this);
    }
  }, s = {
    id: e.id,
    state: "closed",
    el: e,
    trigger: t,
    popper: Vs(t, e),
    config: si(e, this.settings),
    ...n
  };
  return s.trigger.hasAttribute("aria-controls") && s.trigger.setAttribute("aria-expanded", "false"), wi.call(this, s), this.collection.push(s), s.el.classList.contains(this.settings.stateActive) && (await s.open(), ci.call(this, s)), s;
}
function wi(e) {
  return e.__eventListeners || (e.config.event === "hover" ? (e.__eventListeners = [{
    el: ["trigger"],
    type: ["mouseenter", "focus"],
    listener: Ee.bind(this, e)
  }, {
    el: ["el", "trigger"],
    type: ["mouseleave", "focusout"],
    listener: li.bind(this, e)
  }], e.__eventListeners.forEach((t) => {
    t.el.forEach((i) => {
      t.type.forEach((n) => {
        e[i].addEventListener(n, t.listener, !1);
      });
    });
  })) : (e.__eventListeners = [{
    el: ["trigger"],
    type: ["click"],
    listener: jn.bind(this, e)
  }], e.__eventListeners.forEach((t) => {
    t.el.forEach((i) => {
      t.type.forEach((n) => {
        e[i].addEventListener(n, t.listener, !1);
      });
    });
  }))), e;
}
var Tt;
class rr extends qn {
  constructor(t) {
    super(), In(this, Tt, void 0), this.defaults = Pn, this.settings = { ...this.defaults, ...t }, this.trigger = null, Sn(this, Tt, Nn.bind(this)), this.settings.autoInit && this.init();
  }
  async init(t) {
    t && (this.settings = { ...this.settings, ...t });
    const i = document.querySelectorAll(this.settings.selectorPopover);
    return await this.registerCollection(i), this.settings.eventListeners && this.initEventListeners(!1), this;
  }
  async destroy() {
    return this.trigger = null, await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(!1), this;
  }
  initEventListeners(t = !0) {
    t && this.collection.forEach((i) => {
      wi.call(this, i);
    }), document.addEventListener("keydown", je(this, Tt), !1);
  }
  destroyEventListeners(t = !0) {
    t && this.collection.forEach((i) => {
      yi(i);
    }), document.removeEventListener("keydown", je(this, Tt), !1);
  }
  register(t) {
    const i = Wn.call(this, t);
    return i.error ? Promise.reject(i.error) : Js.call(this, i.popover, i.trigger);
  }
  deregister(t) {
    const i = this.get(oi.call(this, t));
    return ae.call(this, i);
  }
  open(t) {
    return Ee.call(this, t);
  }
  close(t) {
    return pe.call(this, t);
  }
}
Tt = /* @__PURE__ */ new WeakMap();
export {
  Zs as Checkbox,
  er as Drawer,
  sr as Modal,
  rr as Popover,
  Qs as core
};
//# sourceMappingURL=index.js.map
